
# Cisco NX OS Resource Provider

The Cisco NX OS resource provider for Pulumi lets you creating resources in the [Cisco NX-OS XE](https://www.cisco.com/c/en/us/products/ios-nx-os-software/nx-os/index.html) API. To use
this package, please [install the Pulumi CLI first](https://pulumi.com/).

## Installing

This package is available in many languages in the standard packaging formats.

### Node.js (Java/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```
$ npm install @lbrlabs/pulumi-nxos
```

or `yarn`:

```
$ yarn add @lbrlabs/pulumi-nxos
```

### Python

To use from Python, install using `pip`:

```
$ pip install lbrlabs_pulumi_nxos
```

### Go

To use from Go, use `go get` to grab the latest version of the library

```
$ go get github.com/lbrlabs/pulumi-nxos/sdk/go/...
```

### .NET

To use from Dotnet, use `dotnet add package` to install into your project. You must specify the version if it is a pre-release version.


```
$ dotnet add package Lbrlabs.PulumiPackage.nxos
```

## Reference

See the Pulumi registry for API docs:

https://www.pulumi.com/registry/packages/nxos/api-docs/
