# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['BgpGracefulRestartArgs', 'BgpGracefulRestart']

@pulumi.input_type
class BgpGracefulRestartArgs:
    def __init__(__self__, *,
                 asn: pulumi.Input[str],
                 vrf: pulumi.Input[str],
                 device: Optional[pulumi.Input[str]] = None,
                 restart_interval: Optional[pulumi.Input[int]] = None,
                 stale_interval: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a BgpGracefulRestart resource.
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] vrf: VRF name.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] restart_interval: The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        :param pulumi.Input[int] stale_interval: The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        """
        pulumi.set(__self__, "asn", asn)
        pulumi.set(__self__, "vrf", vrf)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if restart_interval is not None:
            pulumi.set(__self__, "restart_interval", restart_interval)
        if stale_interval is not None:
            pulumi.set(__self__, "stale_interval", stale_interval)

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Input[str]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: pulumi.Input[str]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter
    def vrf(self) -> pulumi.Input[str]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

    @vrf.setter
    def vrf(self, value: pulumi.Input[str]):
        pulumi.set(self, "vrf", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="restartInterval")
    def restart_interval(self) -> Optional[pulumi.Input[int]]:
        """
        The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        """
        return pulumi.get(self, "restart_interval")

    @restart_interval.setter
    def restart_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "restart_interval", value)

    @property
    @pulumi.getter(name="staleInterval")
    def stale_interval(self) -> Optional[pulumi.Input[int]]:
        """
        The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        """
        return pulumi.get(self, "stale_interval")

    @stale_interval.setter
    def stale_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "stale_interval", value)


@pulumi.input_type
class _BgpGracefulRestartState:
    def __init__(__self__, *,
                 asn: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 restart_interval: Optional[pulumi.Input[int]] = None,
                 stale_interval: Optional[pulumi.Input[int]] = None,
                 vrf: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BgpGracefulRestart resources.
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] restart_interval: The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        :param pulumi.Input[int] stale_interval: The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        :param pulumi.Input[str] vrf: VRF name.
        """
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if restart_interval is not None:
            pulumi.set(__self__, "restart_interval", restart_interval)
        if stale_interval is not None:
            pulumi.set(__self__, "stale_interval", stale_interval)
        if vrf is not None:
            pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter
    def asn(self) -> Optional[pulumi.Input[str]]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="restartInterval")
    def restart_interval(self) -> Optional[pulumi.Input[int]]:
        """
        The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        """
        return pulumi.get(self, "restart_interval")

    @restart_interval.setter
    def restart_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "restart_interval", value)

    @property
    @pulumi.getter(name="staleInterval")
    def stale_interval(self) -> Optional[pulumi.Input[int]]:
        """
        The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        """
        return pulumi.get(self, "stale_interval")

    @stale_interval.setter
    def stale_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "stale_interval", value)

    @property
    @pulumi.getter
    def vrf(self) -> Optional[pulumi.Input[str]]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

    @vrf.setter
    def vrf(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vrf", value)


class BgpGracefulRestart(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 restart_interval: Optional[pulumi.Input[int]] = None,
                 stale_interval: Optional[pulumi.Input[int]] = None,
                 vrf: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage the BGP domain (VRF) graceful restart configuration.

        - API Documentation: [bgpGr](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:Gr/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BgpGracefulRestart("example",
            asn="65001",
            restart_interval=240,
            stale_interval=1800,
            vrf="default")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bgpGracefulRestart:BgpGracefulRestart example "sys/bgp/inst/dom-[default]/gr"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] restart_interval: The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        :param pulumi.Input[int] stale_interval: The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        :param pulumi.Input[str] vrf: VRF name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BgpGracefulRestartArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the BGP domain (VRF) graceful restart configuration.

        - API Documentation: [bgpGr](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:Gr/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BgpGracefulRestart("example",
            asn="65001",
            restart_interval=240,
            stale_interval=1800,
            vrf="default")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bgpGracefulRestart:BgpGracefulRestart example "sys/bgp/inst/dom-[default]/gr"
        ```

        :param str resource_name: The name of the resource.
        :param BgpGracefulRestartArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BgpGracefulRestartArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 restart_interval: Optional[pulumi.Input[int]] = None,
                 stale_interval: Optional[pulumi.Input[int]] = None,
                 vrf: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BgpGracefulRestartArgs.__new__(BgpGracefulRestartArgs)

            if asn is None and not opts.urn:
                raise TypeError("Missing required property 'asn'")
            __props__.__dict__["asn"] = asn
            __props__.__dict__["device"] = device
            __props__.__dict__["restart_interval"] = restart_interval
            __props__.__dict__["stale_interval"] = stale_interval
            if vrf is None and not opts.urn:
                raise TypeError("Missing required property 'vrf'")
            __props__.__dict__["vrf"] = vrf
        super(BgpGracefulRestart, __self__).__init__(
            'nxos:index/bgpGracefulRestart:BgpGracefulRestart',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            asn: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            restart_interval: Optional[pulumi.Input[int]] = None,
            stale_interval: Optional[pulumi.Input[int]] = None,
            vrf: Optional[pulumi.Input[str]] = None) -> 'BgpGracefulRestart':
        """
        Get an existing BgpGracefulRestart resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] restart_interval: The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        :param pulumi.Input[int] stale_interval: The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        :param pulumi.Input[str] vrf: VRF name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BgpGracefulRestartState.__new__(_BgpGracefulRestartState)

        __props__.__dict__["asn"] = asn
        __props__.__dict__["device"] = device
        __props__.__dict__["restart_interval"] = restart_interval
        __props__.__dict__["stale_interval"] = stale_interval
        __props__.__dict__["vrf"] = vrf
        return BgpGracefulRestart(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Output[str]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="restartInterval")
    def restart_interval(self) -> pulumi.Output[int]:
        """
        The graceful restart interval. - Range: `1`-`3600` - Default value: `120`
        """
        return pulumi.get(self, "restart_interval")

    @property
    @pulumi.getter(name="staleInterval")
    def stale_interval(self) -> pulumi.Output[int]:
        """
        The stale interval for routes advertised by the BGP peer. - Range: `1`-`3600` - Default value: `300`
        """
        return pulumi.get(self, "stale_interval")

    @property
    @pulumi.getter
    def vrf(self) -> pulumi.Output[str]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

