# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['BgpPeerAddressFamilyArgs', 'BgpPeerAddressFamily']

@pulumi.input_type
class BgpPeerAddressFamilyArgs:
    def __init__(__self__, *,
                 address: pulumi.Input[str],
                 address_family: pulumi.Input[str],
                 asn: pulumi.Input[str],
                 vrf: pulumi.Input[str],
                 control: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 send_community_extended: Optional[pulumi.Input[str]] = None,
                 send_community_standard: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a BgpPeerAddressFamily resource.
        :param pulumi.Input[str] address: Peer address.
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
               value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] vrf: VRF name.
        :param pulumi.Input[str] control: Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
               `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
               Example: `nh-self` - Multiple values (comma-separated). Example:
               `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] send_community_extended: Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] send_community_standard: Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_family", address_family)
        pulumi.set(__self__, "asn", asn)
        pulumi.set(__self__, "vrf", vrf)
        if control is not None:
            pulumi.set(__self__, "control", control)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if send_community_extended is not None:
            pulumi.set(__self__, "send_community_extended", send_community_extended)
        if send_community_standard is not None:
            pulumi.set(__self__, "send_community_standard", send_community_standard)

    @property
    @pulumi.getter
    def address(self) -> pulumi.Input[str]:
        """
        Peer address.
        """
        return pulumi.get(self, "address")

    @address.setter
    def address(self, value: pulumi.Input[str]):
        pulumi.set(self, "address", value)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> pulumi.Input[str]:
        """
        Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
        value: `ipv4-ucast`
        """
        return pulumi.get(self, "address_family")

    @address_family.setter
    def address_family(self, value: pulumi.Input[str]):
        pulumi.set(self, "address_family", value)

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Input[str]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: pulumi.Input[str]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter
    def vrf(self) -> pulumi.Input[str]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

    @vrf.setter
    def vrf(self, value: pulumi.Input[str]):
        pulumi.set(self, "vrf", value)

    @property
    @pulumi.getter
    def control(self) -> Optional[pulumi.Input[str]]:
        """
        Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
        `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
        Example: `nh-self` - Multiple values (comma-separated). Example:
        `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        """
        return pulumi.get(self, "control")

    @control.setter
    def control(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "control", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="sendCommunityExtended")
    def send_community_extended(self) -> Optional[pulumi.Input[str]]:
        """
        Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "send_community_extended")

    @send_community_extended.setter
    def send_community_extended(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "send_community_extended", value)

    @property
    @pulumi.getter(name="sendCommunityStandard")
    def send_community_standard(self) -> Optional[pulumi.Input[str]]:
        """
        Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "send_community_standard")

    @send_community_standard.setter
    def send_community_standard(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "send_community_standard", value)


@pulumi.input_type
class _BgpPeerAddressFamilyState:
    def __init__(__self__, *,
                 address: Optional[pulumi.Input[str]] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 control: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 send_community_extended: Optional[pulumi.Input[str]] = None,
                 send_community_standard: Optional[pulumi.Input[str]] = None,
                 vrf: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BgpPeerAddressFamily resources.
        :param pulumi.Input[str] address: Peer address.
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
               value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] control: Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
               `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
               Example: `nh-self` - Multiple values (comma-separated). Example:
               `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] send_community_extended: Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] send_community_standard: Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] vrf: VRF name.
        """
        if address is not None:
            pulumi.set(__self__, "address", address)
        if address_family is not None:
            pulumi.set(__self__, "address_family", address_family)
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if control is not None:
            pulumi.set(__self__, "control", control)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if send_community_extended is not None:
            pulumi.set(__self__, "send_community_extended", send_community_extended)
        if send_community_standard is not None:
            pulumi.set(__self__, "send_community_standard", send_community_standard)
        if vrf is not None:
            pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter
    def address(self) -> Optional[pulumi.Input[str]]:
        """
        Peer address.
        """
        return pulumi.get(self, "address")

    @address.setter
    def address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address", value)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> Optional[pulumi.Input[str]]:
        """
        Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
        value: `ipv4-ucast`
        """
        return pulumi.get(self, "address_family")

    @address_family.setter
    def address_family(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address_family", value)

    @property
    @pulumi.getter
    def asn(self) -> Optional[pulumi.Input[str]]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter
    def control(self) -> Optional[pulumi.Input[str]]:
        """
        Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
        `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
        Example: `nh-self` - Multiple values (comma-separated). Example:
        `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        """
        return pulumi.get(self, "control")

    @control.setter
    def control(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "control", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="sendCommunityExtended")
    def send_community_extended(self) -> Optional[pulumi.Input[str]]:
        """
        Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "send_community_extended")

    @send_community_extended.setter
    def send_community_extended(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "send_community_extended", value)

    @property
    @pulumi.getter(name="sendCommunityStandard")
    def send_community_standard(self) -> Optional[pulumi.Input[str]]:
        """
        Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "send_community_standard")

    @send_community_standard.setter
    def send_community_standard(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "send_community_standard", value)

    @property
    @pulumi.getter
    def vrf(self) -> Optional[pulumi.Input[str]]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

    @vrf.setter
    def vrf(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vrf", value)


class BgpPeerAddressFamily(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address: Optional[pulumi.Input[str]] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 control: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 send_community_extended: Optional[pulumi.Input[str]] = None,
                 send_community_standard: Optional[pulumi.Input[str]] = None,
                 vrf: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage the BGP peer address family configuration.

        - API Documentation: [bgpPeerAf](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:PeerAf/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BgpPeerAddressFamily("example",
            address="192.168.0.1",
            address_family="ipv4-ucast",
            asn="65001",
            control="nh-self,rr-client",
            send_community_extended="enabled",
            send_community_standard="enabled",
            vrf="default")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bgpPeerAddressFamily:BgpPeerAddressFamily example "sys/bgp/inst/dom-[default]/peer-[192.168.0.1]/af-[ipv4-ucast]"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address: Peer address.
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
               value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] control: Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
               `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
               Example: `nh-self` - Multiple values (comma-separated). Example:
               `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] send_community_extended: Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] send_community_standard: Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] vrf: VRF name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BgpPeerAddressFamilyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the BGP peer address family configuration.

        - API Documentation: [bgpPeerAf](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:PeerAf/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BgpPeerAddressFamily("example",
            address="192.168.0.1",
            address_family="ipv4-ucast",
            asn="65001",
            control="nh-self,rr-client",
            send_community_extended="enabled",
            send_community_standard="enabled",
            vrf="default")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bgpPeerAddressFamily:BgpPeerAddressFamily example "sys/bgp/inst/dom-[default]/peer-[192.168.0.1]/af-[ipv4-ucast]"
        ```

        :param str resource_name: The name of the resource.
        :param BgpPeerAddressFamilyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BgpPeerAddressFamilyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address: Optional[pulumi.Input[str]] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 control: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 send_community_extended: Optional[pulumi.Input[str]] = None,
                 send_community_standard: Optional[pulumi.Input[str]] = None,
                 vrf: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BgpPeerAddressFamilyArgs.__new__(BgpPeerAddressFamilyArgs)

            if address is None and not opts.urn:
                raise TypeError("Missing required property 'address'")
            __props__.__dict__["address"] = address
            if address_family is None and not opts.urn:
                raise TypeError("Missing required property 'address_family'")
            __props__.__dict__["address_family"] = address_family
            if asn is None and not opts.urn:
                raise TypeError("Missing required property 'asn'")
            __props__.__dict__["asn"] = asn
            __props__.__dict__["control"] = control
            __props__.__dict__["device"] = device
            __props__.__dict__["send_community_extended"] = send_community_extended
            __props__.__dict__["send_community_standard"] = send_community_standard
            if vrf is None and not opts.urn:
                raise TypeError("Missing required property 'vrf'")
            __props__.__dict__["vrf"] = vrf
        super(BgpPeerAddressFamily, __self__).__init__(
            'nxos:index/bgpPeerAddressFamily:BgpPeerAddressFamily',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            address: Optional[pulumi.Input[str]] = None,
            address_family: Optional[pulumi.Input[str]] = None,
            asn: Optional[pulumi.Input[str]] = None,
            control: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            send_community_extended: Optional[pulumi.Input[str]] = None,
            send_community_standard: Optional[pulumi.Input[str]] = None,
            vrf: Optional[pulumi.Input[str]] = None) -> 'BgpPeerAddressFamily':
        """
        Get an existing BgpPeerAddressFamily resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address: Peer address.
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
               value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] control: Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
               `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
               Example: `nh-self` - Multiple values (comma-separated). Example:
               `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] send_community_extended: Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] send_community_standard: Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] vrf: VRF name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BgpPeerAddressFamilyState.__new__(_BgpPeerAddressFamilyState)

        __props__.__dict__["address"] = address
        __props__.__dict__["address_family"] = address_family
        __props__.__dict__["asn"] = asn
        __props__.__dict__["control"] = control
        __props__.__dict__["device"] = device
        __props__.__dict__["send_community_extended"] = send_community_extended
        __props__.__dict__["send_community_standard"] = send_community_standard
        __props__.__dict__["vrf"] = vrf
        return BgpPeerAddressFamily(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def address(self) -> pulumi.Output[str]:
        """
        Peer address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> pulumi.Output[str]:
        """
        Address Family. - Choices: `ipv4-ucast`, `vpnv4-ucast`, `ipv6-ucast`, `vpnv6-ucast`, `l2vpn-evpn`, `lnkstate` - Default
        value: `ipv4-ucast`
        """
        return pulumi.get(self, "address_family")

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Output[str]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter
    def control(self) -> pulumi.Output[Optional[str]]:
        """
        Peer address-family control. Choices: `rr-client`, `nh-self`, `dis-peer-as-check`, `allow-self-as`, `default-originate`,
        `advertisement-interval`, `suppress-inactive`, `nh-self-all`. Can be an empty string. Allowed formats: - Single value.
        Example: `nh-self` - Multiple values (comma-separated). Example:
        `dis-peer-as-check,nh-self,rr-client,suppress-inactive`. In this case values must be in alphabetical order.
        """
        return pulumi.get(self, "control")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="sendCommunityExtended")
    def send_community_extended(self) -> pulumi.Output[str]:
        """
        Send-community extended. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "send_community_extended")

    @property
    @pulumi.getter(name="sendCommunityStandard")
    def send_community_standard(self) -> pulumi.Output[str]:
        """
        Send-community standard. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "send_community_standard")

    @property
    @pulumi.getter
    def vrf(self) -> pulumi.Output[str]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

