# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['BgpPeerTemplateMaxPrefixArgs', 'BgpPeerTemplateMaxPrefix']

@pulumi.input_type
class BgpPeerTemplateMaxPrefixArgs:
    def __init__(__self__, *,
                 address_family: pulumi.Input[str],
                 asn: pulumi.Input[str],
                 template_name: pulumi.Input[str],
                 action: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 maximum_prefix: Optional[pulumi.Input[int]] = None,
                 restart_time: Optional[pulumi.Input[int]] = None,
                 threshold: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a BgpPeerTemplateMaxPrefix resource.
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
               `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
               `ipv4-mdt` - Default value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] template_name: Peer template name.
        :param pulumi.Input[str] action: Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] maximum_prefix: Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        :param pulumi.Input[int] restart_time: The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        :param pulumi.Input[int] threshold: The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
               value: `0`
        """
        pulumi.set(__self__, "address_family", address_family)
        pulumi.set(__self__, "asn", asn)
        pulumi.set(__self__, "template_name", template_name)
        if action is not None:
            pulumi.set(__self__, "action", action)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if maximum_prefix is not None:
            pulumi.set(__self__, "maximum_prefix", maximum_prefix)
        if restart_time is not None:
            pulumi.set(__self__, "restart_time", restart_time)
        if threshold is not None:
            pulumi.set(__self__, "threshold", threshold)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> pulumi.Input[str]:
        """
        Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
        `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
        `ipv4-mdt` - Default value: `ipv4-ucast`
        """
        return pulumi.get(self, "address_family")

    @address_family.setter
    def address_family(self, value: pulumi.Input[str]):
        pulumi.set(self, "address_family", value)

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Input[str]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: pulumi.Input[str]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> pulumi.Input[str]:
        """
        Peer template name.
        """
        return pulumi.get(self, "template_name")

    @template_name.setter
    def template_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "template_name", value)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="maximumPrefix")
    def maximum_prefix(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        """
        return pulumi.get(self, "maximum_prefix")

    @maximum_prefix.setter
    def maximum_prefix(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "maximum_prefix", value)

    @property
    @pulumi.getter(name="restartTime")
    def restart_time(self) -> Optional[pulumi.Input[int]]:
        """
        The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        """
        return pulumi.get(self, "restart_time")

    @restart_time.setter
    def restart_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "restart_time", value)

    @property
    @pulumi.getter
    def threshold(self) -> Optional[pulumi.Input[int]]:
        """
        The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
        value: `0`
        """
        return pulumi.get(self, "threshold")

    @threshold.setter
    def threshold(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "threshold", value)


@pulumi.input_type
class _BgpPeerTemplateMaxPrefixState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 maximum_prefix: Optional[pulumi.Input[int]] = None,
                 restart_time: Optional[pulumi.Input[int]] = None,
                 template_name: Optional[pulumi.Input[str]] = None,
                 threshold: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering BgpPeerTemplateMaxPrefix resources.
        :param pulumi.Input[str] action: Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
               `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
               `ipv4-mdt` - Default value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] maximum_prefix: Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        :param pulumi.Input[int] restart_time: The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        :param pulumi.Input[str] template_name: Peer template name.
        :param pulumi.Input[int] threshold: The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
               value: `0`
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if address_family is not None:
            pulumi.set(__self__, "address_family", address_family)
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if maximum_prefix is not None:
            pulumi.set(__self__, "maximum_prefix", maximum_prefix)
        if restart_time is not None:
            pulumi.set(__self__, "restart_time", restart_time)
        if template_name is not None:
            pulumi.set(__self__, "template_name", template_name)
        if threshold is not None:
            pulumi.set(__self__, "threshold", threshold)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> Optional[pulumi.Input[str]]:
        """
        Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
        `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
        `ipv4-mdt` - Default value: `ipv4-ucast`
        """
        return pulumi.get(self, "address_family")

    @address_family.setter
    def address_family(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address_family", value)

    @property
    @pulumi.getter
    def asn(self) -> Optional[pulumi.Input[str]]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="maximumPrefix")
    def maximum_prefix(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        """
        return pulumi.get(self, "maximum_prefix")

    @maximum_prefix.setter
    def maximum_prefix(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "maximum_prefix", value)

    @property
    @pulumi.getter(name="restartTime")
    def restart_time(self) -> Optional[pulumi.Input[int]]:
        """
        The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        """
        return pulumi.get(self, "restart_time")

    @restart_time.setter
    def restart_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "restart_time", value)

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> Optional[pulumi.Input[str]]:
        """
        Peer template name.
        """
        return pulumi.get(self, "template_name")

    @template_name.setter
    def template_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "template_name", value)

    @property
    @pulumi.getter
    def threshold(self) -> Optional[pulumi.Input[int]]:
        """
        The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
        value: `0`
        """
        return pulumi.get(self, "threshold")

    @threshold.setter
    def threshold(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "threshold", value)


class BgpPeerTemplateMaxPrefix(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 maximum_prefix: Optional[pulumi.Input[int]] = None,
                 restart_time: Optional[pulumi.Input[int]] = None,
                 template_name: Optional[pulumi.Input[str]] = None,
                 threshold: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        This resource can manage the BGP peer template Maximum Prefix Policy configuration.

        - API Documentation: [bgpMaxPfxP](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:MaxPfxP/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BgpPeerTemplateMaxPrefix("example",
            action="log",
            address_family="ipv4-ucast",
            asn="65001",
            maximum_prefix=10000,
            restart_time=0,
            template_name="SPINE-PEERS",
            threshold=30)
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bgpPeerTemplateMaxPrefix:BgpPeerTemplateMaxPrefix example "sys/bgp/inst/dom-[default]/peercont-[SPINE-PEERS]/af-[ipv4-ucast]/maxpfxp"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
               `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
               `ipv4-mdt` - Default value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] maximum_prefix: Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        :param pulumi.Input[int] restart_time: The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        :param pulumi.Input[str] template_name: Peer template name.
        :param pulumi.Input[int] threshold: The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
               value: `0`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BgpPeerTemplateMaxPrefixArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the BGP peer template Maximum Prefix Policy configuration.

        - API Documentation: [bgpMaxPfxP](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:MaxPfxP/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BgpPeerTemplateMaxPrefix("example",
            action="log",
            address_family="ipv4-ucast",
            asn="65001",
            maximum_prefix=10000,
            restart_time=0,
            template_name="SPINE-PEERS",
            threshold=30)
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bgpPeerTemplateMaxPrefix:BgpPeerTemplateMaxPrefix example "sys/bgp/inst/dom-[default]/peercont-[SPINE-PEERS]/af-[ipv4-ucast]/maxpfxp"
        ```

        :param str resource_name: The name of the resource.
        :param BgpPeerTemplateMaxPrefixArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BgpPeerTemplateMaxPrefixArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 asn: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 maximum_prefix: Optional[pulumi.Input[int]] = None,
                 restart_time: Optional[pulumi.Input[int]] = None,
                 template_name: Optional[pulumi.Input[str]] = None,
                 threshold: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BgpPeerTemplateMaxPrefixArgs.__new__(BgpPeerTemplateMaxPrefixArgs)

            __props__.__dict__["action"] = action
            if address_family is None and not opts.urn:
                raise TypeError("Missing required property 'address_family'")
            __props__.__dict__["address_family"] = address_family
            if asn is None and not opts.urn:
                raise TypeError("Missing required property 'asn'")
            __props__.__dict__["asn"] = asn
            __props__.__dict__["device"] = device
            __props__.__dict__["maximum_prefix"] = maximum_prefix
            __props__.__dict__["restart_time"] = restart_time
            if template_name is None and not opts.urn:
                raise TypeError("Missing required property 'template_name'")
            __props__.__dict__["template_name"] = template_name
            __props__.__dict__["threshold"] = threshold
        super(BgpPeerTemplateMaxPrefix, __self__).__init__(
            'nxos:index/bgpPeerTemplateMaxPrefix:BgpPeerTemplateMaxPrefix',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            address_family: Optional[pulumi.Input[str]] = None,
            asn: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            maximum_prefix: Optional[pulumi.Input[int]] = None,
            restart_time: Optional[pulumi.Input[int]] = None,
            template_name: Optional[pulumi.Input[str]] = None,
            threshold: Optional[pulumi.Input[int]] = None) -> 'BgpPeerTemplateMaxPrefix':
        """
        Get an existing BgpPeerTemplateMaxPrefix resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        :param pulumi.Input[str] address_family: Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
               `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
               `ipv4-mdt` - Default value: `ipv4-ucast`
        :param pulumi.Input[str] asn: Autonomous system number.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] maximum_prefix: Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        :param pulumi.Input[int] restart_time: The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        :param pulumi.Input[str] template_name: Peer template name.
        :param pulumi.Input[int] threshold: The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
               value: `0`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BgpPeerTemplateMaxPrefixState.__new__(_BgpPeerTemplateMaxPrefixState)

        __props__.__dict__["action"] = action
        __props__.__dict__["address_family"] = address_family
        __props__.__dict__["asn"] = asn
        __props__.__dict__["device"] = device
        __props__.__dict__["maximum_prefix"] = maximum_prefix
        __props__.__dict__["restart_time"] = restart_time
        __props__.__dict__["template_name"] = template_name
        __props__.__dict__["threshold"] = threshold
        return BgpPeerTemplateMaxPrefix(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        Action to do when limit is exceeded. - Choices: `log`, `shut`, `restart` - Default value: `shut`
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> pulumi.Output[str]:
        """
        Address Family. - Choices: `ipv4-ucast`, `ipv4-mcast`, `vpnv4-ucast`, `ipv6-ucast`, `ipv6-mcast`, `vpnv6-ucast`,
        `vpnv6-mcast`, `l2vpn-evpn`, `ipv4-lucast`, `ipv6-lucast`, `lnkstate`, `ipv4-mvpn`, `ipv6-mvpn`, `l2vpn-vpls`,
        `ipv4-mdt` - Default value: `ipv4-ucast`
        """
        return pulumi.get(self, "address_family")

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Output[str]:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="maximumPrefix")
    def maximum_prefix(self) -> pulumi.Output[Optional[int]]:
        """
        Maximum number of prefixes allowed from the peer. - Range: `0`-`4294967295`
        """
        return pulumi.get(self, "maximum_prefix")

    @property
    @pulumi.getter(name="restartTime")
    def restart_time(self) -> pulumi.Output[int]:
        """
        The period of time in minutes before restarting the peer when the prefix limit is reached. - Default value: `0`
        """
        return pulumi.get(self, "restart_time")

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> pulumi.Output[str]:
        """
        Peer template name.
        """
        return pulumi.get(self, "template_name")

    @property
    @pulumi.getter
    def threshold(self) -> pulumi.Output[int]:
        """
        The period of time in minutes before restarting the peer when the prefix limit is reached. - Range: `0`-`100` - Default
        value: `0`
        """
        return pulumi.get(self, "threshold")

