# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['BridgeDomainArgs', 'BridgeDomain']

@pulumi.input_type
class BridgeDomainArgs:
    def __init__(__self__, *,
                 fabric_encap: pulumi.Input[str],
                 access_encap: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a BridgeDomain resource.
        :param pulumi.Input[str] fabric_encap: Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] access_encap: Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] name: Bridge domain name.
        """
        pulumi.set(__self__, "fabric_encap", fabric_encap)
        if access_encap is not None:
            pulumi.set(__self__, "access_encap", access_encap)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="fabricEncap")
    def fabric_encap(self) -> pulumi.Input[str]:
        """
        Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        """
        return pulumi.get(self, "fabric_encap")

    @fabric_encap.setter
    def fabric_encap(self, value: pulumi.Input[str]):
        pulumi.set(self, "fabric_encap", value)

    @property
    @pulumi.getter(name="accessEncap")
    def access_encap(self) -> Optional[pulumi.Input[str]]:
        """
        Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        """
        return pulumi.get(self, "access_encap")

    @access_encap.setter
    def access_encap(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_encap", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Bridge domain name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _BridgeDomainState:
    def __init__(__self__, *,
                 access_encap: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 fabric_encap: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BridgeDomain resources.
        :param pulumi.Input[str] access_encap: Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] fabric_encap: Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] name: Bridge domain name.
        """
        if access_encap is not None:
            pulumi.set(__self__, "access_encap", access_encap)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if fabric_encap is not None:
            pulumi.set(__self__, "fabric_encap", fabric_encap)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="accessEncap")
    def access_encap(self) -> Optional[pulumi.Input[str]]:
        """
        Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        """
        return pulumi.get(self, "access_encap")

    @access_encap.setter
    def access_encap(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_encap", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="fabricEncap")
    def fabric_encap(self) -> Optional[pulumi.Input[str]]:
        """
        Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        """
        return pulumi.get(self, "fabric_encap")

    @fabric_encap.setter
    def fabric_encap(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fabric_encap", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Bridge domain name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class BridgeDomain(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_encap: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 fabric_encap: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a bridge domain.

        - API Documentation: [l2BD](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%202/l2:BD/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BridgeDomain("example",
            access_encap="unknown",
            fabric_encap="vlan-10")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bridgeDomain:BridgeDomain example "sys/bd/bd-[vlan-10]"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_encap: Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] fabric_encap: Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] name: Bridge domain name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BridgeDomainArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a bridge domain.

        - API Documentation: [l2BD](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%202/l2:BD/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.BridgeDomain("example",
            access_encap="unknown",
            fabric_encap="vlan-10")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/bridgeDomain:BridgeDomain example "sys/bd/bd-[vlan-10]"
        ```

        :param str resource_name: The name of the resource.
        :param BridgeDomainArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BridgeDomainArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_encap: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 fabric_encap: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BridgeDomainArgs.__new__(BridgeDomainArgs)

            __props__.__dict__["access_encap"] = access_encap
            __props__.__dict__["device"] = device
            if fabric_encap is None and not opts.urn:
                raise TypeError("Missing required property 'fabric_encap'")
            __props__.__dict__["fabric_encap"] = fabric_encap
            __props__.__dict__["name"] = name
        super(BridgeDomain, __self__).__init__(
            'nxos:index/bridgeDomain:BridgeDomain',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_encap: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            fabric_encap: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'BridgeDomain':
        """
        Get an existing BridgeDomain resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_encap: Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] fabric_encap: Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        :param pulumi.Input[str] name: Bridge domain name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BridgeDomainState.__new__(_BridgeDomainState)

        __props__.__dict__["access_encap"] = access_encap
        __props__.__dict__["device"] = device
        __props__.__dict__["fabric_encap"] = fabric_encap
        __props__.__dict__["name"] = name
        return BridgeDomain(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessEncap")
    def access_encap(self) -> pulumi.Output[str]:
        """
        Access encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        """
        return pulumi.get(self, "access_encap")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="fabricEncap")
    def fabric_encap(self) -> pulumi.Output[str]:
        """
        Fabric encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `unknown`
        """
        return pulumi.get(self, "fabric_encap")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Bridge domain name.
        """
        return pulumi.get(self, "name")

