# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['DefaultQosPolicyInterfaceInPolicyMapArgs', 'DefaultQosPolicyInterfaceInPolicyMap']

@pulumi.input_type
class DefaultQosPolicyInterfaceInPolicyMapArgs:
    def __init__(__self__, *,
                 interface_id: pulumi.Input[str],
                 policy_map_name: pulumi.Input[str],
                 device: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a DefaultQosPolicyInterfaceInPolicyMap resource.
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        :param pulumi.Input[str] policy_map_name: Policy map name.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        pulumi.set(__self__, "interface_id", interface_id)
        pulumi.set(__self__, "policy_map_name", policy_map_name)
        if device is not None:
            pulumi.set(__self__, "device", device)

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> pulumi.Input[str]:
        """
        Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        """
        return pulumi.get(self, "interface_id")

    @interface_id.setter
    def interface_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "interface_id", value)

    @property
    @pulumi.getter(name="policyMapName")
    def policy_map_name(self) -> pulumi.Input[str]:
        """
        Policy map name.
        """
        return pulumi.get(self, "policy_map_name")

    @policy_map_name.setter
    def policy_map_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "policy_map_name", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)


@pulumi.input_type
class _DefaultQosPolicyInterfaceInPolicyMapState:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 interface_id: Optional[pulumi.Input[str]] = None,
                 policy_map_name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DefaultQosPolicyInterfaceInPolicyMap resources.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        :param pulumi.Input[str] policy_map_name: Policy map name.
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if interface_id is not None:
            pulumi.set(__self__, "interface_id", interface_id)
        if policy_map_name is not None:
            pulumi.set(__self__, "policy_map_name", policy_map_name)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> Optional[pulumi.Input[str]]:
        """
        Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        """
        return pulumi.get(self, "interface_id")

    @interface_id.setter
    def interface_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "interface_id", value)

    @property
    @pulumi.getter(name="policyMapName")
    def policy_map_name(self) -> Optional[pulumi.Input[str]]:
        """
        Policy map name.
        """
        return pulumi.get(self, "policy_map_name")

    @policy_map_name.setter
    def policy_map_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "policy_map_name", value)


class DefaultQosPolicyInterfaceInPolicyMap(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 interface_id: Optional[pulumi.Input[str]] = None,
                 policy_map_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage the default QoS policy interface in policy map configuration.

        - API Documentation: [ipqosInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:Inst/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.DefaultQosPolicyInterfaceInPolicyMap("example",
            interface_id="eth1/10",
            policy_map_name="PM1")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/defaultQosPolicyInterfaceInPolicyMap:DefaultQosPolicyInterfaceInPolicyMap example "sys/ipqos/dflt/policy/in/intf-[eth1/10]/pmap"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        :param pulumi.Input[str] policy_map_name: Policy map name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DefaultQosPolicyInterfaceInPolicyMapArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the default QoS policy interface in policy map configuration.

        - API Documentation: [ipqosInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:Inst/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.DefaultQosPolicyInterfaceInPolicyMap("example",
            interface_id="eth1/10",
            policy_map_name="PM1")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/defaultQosPolicyInterfaceInPolicyMap:DefaultQosPolicyInterfaceInPolicyMap example "sys/ipqos/dflt/policy/in/intf-[eth1/10]/pmap"
        ```

        :param str resource_name: The name of the resource.
        :param DefaultQosPolicyInterfaceInPolicyMapArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DefaultQosPolicyInterfaceInPolicyMapArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 interface_id: Optional[pulumi.Input[str]] = None,
                 policy_map_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DefaultQosPolicyInterfaceInPolicyMapArgs.__new__(DefaultQosPolicyInterfaceInPolicyMapArgs)

            __props__.__dict__["device"] = device
            if interface_id is None and not opts.urn:
                raise TypeError("Missing required property 'interface_id'")
            __props__.__dict__["interface_id"] = interface_id
            if policy_map_name is None and not opts.urn:
                raise TypeError("Missing required property 'policy_map_name'")
            __props__.__dict__["policy_map_name"] = policy_map_name
        super(DefaultQosPolicyInterfaceInPolicyMap, __self__).__init__(
            'nxos:index/defaultQosPolicyInterfaceInPolicyMap:DefaultQosPolicyInterfaceInPolicyMap',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            device: Optional[pulumi.Input[str]] = None,
            interface_id: Optional[pulumi.Input[str]] = None,
            policy_map_name: Optional[pulumi.Input[str]] = None) -> 'DefaultQosPolicyInterfaceInPolicyMap':
        """
        Get an existing DefaultQosPolicyInterfaceInPolicyMap resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        :param pulumi.Input[str] policy_map_name: Policy map name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DefaultQosPolicyInterfaceInPolicyMapState.__new__(_DefaultQosPolicyInterfaceInPolicyMapState)

        __props__.__dict__["device"] = device
        __props__.__dict__["interface_id"] = interface_id
        __props__.__dict__["policy_map_name"] = policy_map_name
        return DefaultQosPolicyInterfaceInPolicyMap(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> pulumi.Output[str]:
        """
        Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        """
        return pulumi.get(self, "interface_id")

    @property
    @pulumi.getter(name="policyMapName")
    def policy_map_name(self) -> pulumi.Output[str]:
        """
        Policy map name.
        """
        return pulumi.get(self, "policy_map_name")

