# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['EthernetArgs', 'Ethernet']

@pulumi.input_type
class EthernetArgs:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Ethernet resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] mtu: System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def mtu(self) -> Optional[pulumi.Input[int]]:
        """
        System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        return pulumi.get(self, "mtu")

    @mtu.setter
    def mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mtu", value)


@pulumi.input_type
class _EthernetState:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering Ethernet resources.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] mtu: System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def mtu(self) -> Optional[pulumi.Input[int]]:
        """
        System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        return pulumi.get(self, "mtu")

    @mtu.setter
    def mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mtu", value)


class Ethernet(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        This resource can manage global ethernet settings.

        - API Documentation: [ethpmInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Interfaces/ethpm:Inst/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.Ethernet("example", mtu=9216)
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/ethernet:Ethernet example "sys/ethpm/inst"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] mtu: System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[EthernetArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage global ethernet settings.

        - API Documentation: [ethpmInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Interfaces/ethpm:Inst/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.Ethernet("example", mtu=9216)
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/ethernet:Ethernet example "sys/ethpm/inst"
        ```

        :param str resource_name: The name of the resource.
        :param EthernetArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(EthernetArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = EthernetArgs.__new__(EthernetArgs)

            __props__.__dict__["device"] = device
            __props__.__dict__["mtu"] = mtu
        super(Ethernet, __self__).__init__(
            'nxos:index/ethernet:Ethernet',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            device: Optional[pulumi.Input[str]] = None,
            mtu: Optional[pulumi.Input[int]] = None) -> 'Ethernet':
        """
        Get an existing Ethernet resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] mtu: System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _EthernetState.__new__(_EthernetState)

        __props__.__dict__["device"] = device
        __props__.__dict__["mtu"] = mtu
        return Ethernet(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def mtu(self) -> pulumi.Output[int]:
        """
        System jumbo MTU. - Range: `576`-`9216` - Default value: `9216`
        """
        return pulumi.get(self, "mtu")

