# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetBgpPeerAddressFamilyPrefixListControlResult',
    'AwaitableGetBgpPeerAddressFamilyPrefixListControlResult',
    'get_bgp_peer_address_family_prefix_list_control',
    'get_bgp_peer_address_family_prefix_list_control_output',
]

@pulumi.output_type
class GetBgpPeerAddressFamilyPrefixListControlResult:
    """
    A collection of values returned by getBgpPeerAddressFamilyPrefixListControl.
    """
    def __init__(__self__, address=None, address_family=None, asn=None, device=None, direction=None, id=None, list=None, vrf=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if address_family and not isinstance(address_family, str):
            raise TypeError("Expected argument 'address_family' to be a str")
        pulumi.set(__self__, "address_family", address_family)
        if asn and not isinstance(asn, str):
            raise TypeError("Expected argument 'asn' to be a str")
        pulumi.set(__self__, "asn", asn)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if direction and not isinstance(direction, str):
            raise TypeError("Expected argument 'direction' to be a str")
        pulumi.set(__self__, "direction", direction)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if list and not isinstance(list, str):
            raise TypeError("Expected argument 'list' to be a str")
        pulumi.set(__self__, "list", list)
        if vrf and not isinstance(vrf, str):
            raise TypeError("Expected argument 'vrf' to be a str")
        pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Peer address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> str:
        """
        Address Family.
        """
        return pulumi.get(self, "address_family")

    @property
    @pulumi.getter
    def asn(self) -> str:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def direction(self) -> str:
        """
        Route Control direction.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def list(self) -> str:
        """
        Route Control Prefix-List name.
        """
        return pulumi.get(self, "list")

    @property
    @pulumi.getter
    def vrf(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")


class AwaitableGetBgpPeerAddressFamilyPrefixListControlResult(GetBgpPeerAddressFamilyPrefixListControlResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBgpPeerAddressFamilyPrefixListControlResult(
            address=self.address,
            address_family=self.address_family,
            asn=self.asn,
            device=self.device,
            direction=self.direction,
            id=self.id,
            list=self.list,
            vrf=self.vrf)


def get_bgp_peer_address_family_prefix_list_control(address: Optional[str] = None,
                                                    address_family: Optional[str] = None,
                                                    asn: Optional[str] = None,
                                                    device: Optional[str] = None,
                                                    direction: Optional[str] = None,
                                                    vrf: Optional[str] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBgpPeerAddressFamilyPrefixListControlResult:
    """
    This data source can read the BGP peer address family prefix list control configuration.

    - API Documentation: [bgpPfxCtrlP](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:PfxCtrlP/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_bgp_peer_address_family_prefix_list_control(address="192.168.0.1",
        address_family="ipv4-ucast",
        asn="65001",
        direction="in",
        vrf="default")
    ```


    :param str address: Peer address.
    :param str address_family: Address Family.
    :param str asn: Autonomous system number.
    :param str device: A device name from the provider configuration.
    :param str direction: Route Control direction.
    :param str vrf: VRF name.
    """
    __args__ = dict()
    __args__['address'] = address
    __args__['addressFamily'] = address_family
    __args__['asn'] = asn
    __args__['device'] = device
    __args__['direction'] = direction
    __args__['vrf'] = vrf
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getBgpPeerAddressFamilyPrefixListControl:getBgpPeerAddressFamilyPrefixListControl', __args__, opts=opts, typ=GetBgpPeerAddressFamilyPrefixListControlResult).value

    return AwaitableGetBgpPeerAddressFamilyPrefixListControlResult(
        address=pulumi.get(__ret__, 'address'),
        address_family=pulumi.get(__ret__, 'address_family'),
        asn=pulumi.get(__ret__, 'asn'),
        device=pulumi.get(__ret__, 'device'),
        direction=pulumi.get(__ret__, 'direction'),
        id=pulumi.get(__ret__, 'id'),
        list=pulumi.get(__ret__, 'list'),
        vrf=pulumi.get(__ret__, 'vrf'))


@_utilities.lift_output_func(get_bgp_peer_address_family_prefix_list_control)
def get_bgp_peer_address_family_prefix_list_control_output(address: Optional[pulumi.Input[str]] = None,
                                                           address_family: Optional[pulumi.Input[str]] = None,
                                                           asn: Optional[pulumi.Input[str]] = None,
                                                           device: Optional[pulumi.Input[Optional[str]]] = None,
                                                           direction: Optional[pulumi.Input[str]] = None,
                                                           vrf: Optional[pulumi.Input[str]] = None,
                                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBgpPeerAddressFamilyPrefixListControlResult]:
    """
    This data source can read the BGP peer address family prefix list control configuration.

    - API Documentation: [bgpPfxCtrlP](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:PfxCtrlP/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_bgp_peer_address_family_prefix_list_control(address="192.168.0.1",
        address_family="ipv4-ucast",
        asn="65001",
        direction="in",
        vrf="default")
    ```


    :param str address: Peer address.
    :param str address_family: Address Family.
    :param str asn: Autonomous system number.
    :param str device: A device name from the provider configuration.
    :param str direction: Route Control direction.
    :param str vrf: VRF name.
    """
    ...
