# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetBgpPeerAddressFamilyRouteControlResult',
    'AwaitableGetBgpPeerAddressFamilyRouteControlResult',
    'get_bgp_peer_address_family_route_control',
    'get_bgp_peer_address_family_route_control_output',
]

@pulumi.output_type
class GetBgpPeerAddressFamilyRouteControlResult:
    """
    A collection of values returned by getBgpPeerAddressFamilyRouteControl.
    """
    def __init__(__self__, address=None, address_family=None, asn=None, device=None, direction=None, id=None, route_map_name=None, vrf=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if address_family and not isinstance(address_family, str):
            raise TypeError("Expected argument 'address_family' to be a str")
        pulumi.set(__self__, "address_family", address_family)
        if asn and not isinstance(asn, str):
            raise TypeError("Expected argument 'asn' to be a str")
        pulumi.set(__self__, "asn", asn)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if direction and not isinstance(direction, str):
            raise TypeError("Expected argument 'direction' to be a str")
        pulumi.set(__self__, "direction", direction)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if route_map_name and not isinstance(route_map_name, str):
            raise TypeError("Expected argument 'route_map_name' to be a str")
        pulumi.set(__self__, "route_map_name", route_map_name)
        if vrf and not isinstance(vrf, str):
            raise TypeError("Expected argument 'vrf' to be a str")
        pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Peer address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> str:
        """
        Address Family.
        """
        return pulumi.get(self, "address_family")

    @property
    @pulumi.getter
    def asn(self) -> str:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def direction(self) -> str:
        """
        Route Control direction.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="routeMapName")
    def route_map_name(self) -> str:
        """
        Route Control Route-Map name.
        """
        return pulumi.get(self, "route_map_name")

    @property
    @pulumi.getter
    def vrf(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")


class AwaitableGetBgpPeerAddressFamilyRouteControlResult(GetBgpPeerAddressFamilyRouteControlResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBgpPeerAddressFamilyRouteControlResult(
            address=self.address,
            address_family=self.address_family,
            asn=self.asn,
            device=self.device,
            direction=self.direction,
            id=self.id,
            route_map_name=self.route_map_name,
            vrf=self.vrf)


def get_bgp_peer_address_family_route_control(address: Optional[str] = None,
                                              address_family: Optional[str] = None,
                                              asn: Optional[str] = None,
                                              device: Optional[str] = None,
                                              direction: Optional[str] = None,
                                              vrf: Optional[str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBgpPeerAddressFamilyRouteControlResult:
    """
    This data source can read the BGP peer address family route control configuration.

    - API Documentation: [bgpRtCtrlP](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:RtCtrlP/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_bgp_peer_address_family_route_control(address="192.168.0.1",
        address_family="ipv4-ucast",
        asn="65001",
        direction="in",
        vrf="default")
    ```


    :param str address: Peer address.
    :param str address_family: Address Family.
    :param str asn: Autonomous system number.
    :param str device: A device name from the provider configuration.
    :param str direction: Route Control direction.
    :param str vrf: VRF name.
    """
    __args__ = dict()
    __args__['address'] = address
    __args__['addressFamily'] = address_family
    __args__['asn'] = asn
    __args__['device'] = device
    __args__['direction'] = direction
    __args__['vrf'] = vrf
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getBgpPeerAddressFamilyRouteControl:getBgpPeerAddressFamilyRouteControl', __args__, opts=opts, typ=GetBgpPeerAddressFamilyRouteControlResult).value

    return AwaitableGetBgpPeerAddressFamilyRouteControlResult(
        address=pulumi.get(__ret__, 'address'),
        address_family=pulumi.get(__ret__, 'address_family'),
        asn=pulumi.get(__ret__, 'asn'),
        device=pulumi.get(__ret__, 'device'),
        direction=pulumi.get(__ret__, 'direction'),
        id=pulumi.get(__ret__, 'id'),
        route_map_name=pulumi.get(__ret__, 'route_map_name'),
        vrf=pulumi.get(__ret__, 'vrf'))


@_utilities.lift_output_func(get_bgp_peer_address_family_route_control)
def get_bgp_peer_address_family_route_control_output(address: Optional[pulumi.Input[str]] = None,
                                                     address_family: Optional[pulumi.Input[str]] = None,
                                                     asn: Optional[pulumi.Input[str]] = None,
                                                     device: Optional[pulumi.Input[Optional[str]]] = None,
                                                     direction: Optional[pulumi.Input[str]] = None,
                                                     vrf: Optional[pulumi.Input[str]] = None,
                                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBgpPeerAddressFamilyRouteControlResult]:
    """
    This data source can read the BGP peer address family route control configuration.

    - API Documentation: [bgpRtCtrlP](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:RtCtrlP/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_bgp_peer_address_family_route_control(address="192.168.0.1",
        address_family="ipv4-ucast",
        asn="65001",
        direction="in",
        vrf="default")
    ```


    :param str address: Peer address.
    :param str address_family: Address Family.
    :param str asn: Autonomous system number.
    :param str device: A device name from the provider configuration.
    :param str direction: Route Control direction.
    :param str vrf: VRF name.
    """
    ...
