# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetBgpVrfResult',
    'AwaitableGetBgpVrfResult',
    'get_bgp_vrf',
    'get_bgp_vrf_output',
]

@pulumi.output_type
class GetBgpVrfResult:
    """
    A collection of values returned by getBgpVrf.
    """
    def __init__(__self__, asn=None, device=None, id=None, name=None, router_id=None):
        if asn and not isinstance(asn, str):
            raise TypeError("Expected argument 'asn' to be a str")
        pulumi.set(__self__, "asn", asn)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if router_id and not isinstance(router_id, str):
            raise TypeError("Expected argument 'router_id' to be a str")
        pulumi.set(__self__, "router_id", router_id)

    @property
    @pulumi.getter
    def asn(self) -> str:
        """
        Autonomous system number.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="routerId")
    def router_id(self) -> str:
        """
        Router ID.
        """
        return pulumi.get(self, "router_id")


class AwaitableGetBgpVrfResult(GetBgpVrfResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBgpVrfResult(
            asn=self.asn,
            device=self.device,
            id=self.id,
            name=self.name,
            router_id=self.router_id)


def get_bgp_vrf(asn: Optional[str] = None,
                device: Optional[str] = None,
                name: Optional[str] = None,
                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBgpVrfResult:
    """
    This data source can read the BGP domain (VRF) configuration.

    - API Documentation: [bgpDom](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:Dom/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_bgp_vrf(asn="65001",
        name="default")
    ```


    :param str asn: Autonomous system number.
    :param str device: A device name from the provider configuration.
    :param str name: VRF name.
    """
    __args__ = dict()
    __args__['asn'] = asn
    __args__['device'] = device
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getBgpVrf:getBgpVrf', __args__, opts=opts, typ=GetBgpVrfResult).value

    return AwaitableGetBgpVrfResult(
        asn=pulumi.get(__ret__, 'asn'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        router_id=pulumi.get(__ret__, 'router_id'))


@_utilities.lift_output_func(get_bgp_vrf)
def get_bgp_vrf_output(asn: Optional[pulumi.Input[str]] = None,
                       device: Optional[pulumi.Input[Optional[str]]] = None,
                       name: Optional[pulumi.Input[str]] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBgpVrfResult]:
    """
    This data source can read the BGP domain (VRF) configuration.

    - API Documentation: [bgpDom](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/bgp:Dom/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_bgp_vrf(asn="65001",
        name="default")
    ```


    :param str asn: Autonomous system number.
    :param str device: A device name from the provider configuration.
    :param str name: VRF name.
    """
    ...
