# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetDefaultQosClassMapDscpResult',
    'AwaitableGetDefaultQosClassMapDscpResult',
    'get_default_qos_class_map_dscp',
    'get_default_qos_class_map_dscp_output',
]

@pulumi.output_type
class GetDefaultQosClassMapDscpResult:
    """
    A collection of values returned by getDefaultQosClassMapDscp.
    """
    def __init__(__self__, class_map_name=None, device=None, id=None, value=None):
        if class_map_name and not isinstance(class_map_name, str):
            raise TypeError("Expected argument 'class_map_name' to be a str")
        pulumi.set(__self__, "class_map_name", class_map_name)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if value and not isinstance(value, str):
            raise TypeError("Expected argument 'value' to be a str")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="classMapName")
    def class_map_name(self) -> str:
        """
        Class map name.
        """
        return pulumi.get(self, "class_map_name")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        DSCP value.
        """
        return pulumi.get(self, "value")


class AwaitableGetDefaultQosClassMapDscpResult(GetDefaultQosClassMapDscpResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDefaultQosClassMapDscpResult(
            class_map_name=self.class_map_name,
            device=self.device,
            id=self.id,
            value=self.value)


def get_default_qos_class_map_dscp(class_map_name: Optional[str] = None,
                                   device: Optional[str] = None,
                                   value: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDefaultQosClassMapDscpResult:
    """
    This data source can read the default QoS class map DSCP configuration.

    - API Documentation: [ipqosDscp](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:Dscp/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_default_qos_class_map_dscp(class_map_name="Voice",
        value="ef")
    ```


    :param str class_map_name: Class map name.
    :param str device: A device name from the provider configuration.
    :param str value: DSCP value.
    """
    __args__ = dict()
    __args__['classMapName'] = class_map_name
    __args__['device'] = device
    __args__['value'] = value
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getDefaultQosClassMapDscp:getDefaultQosClassMapDscp', __args__, opts=opts, typ=GetDefaultQosClassMapDscpResult).value

    return AwaitableGetDefaultQosClassMapDscpResult(
        class_map_name=pulumi.get(__ret__, 'class_map_name'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        value=pulumi.get(__ret__, 'value'))


@_utilities.lift_output_func(get_default_qos_class_map_dscp)
def get_default_qos_class_map_dscp_output(class_map_name: Optional[pulumi.Input[str]] = None,
                                          device: Optional[pulumi.Input[Optional[str]]] = None,
                                          value: Optional[pulumi.Input[str]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDefaultQosClassMapDscpResult]:
    """
    This data source can read the default QoS class map DSCP configuration.

    - API Documentation: [ipqosDscp](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:Dscp/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_default_qos_class_map_dscp(class_map_name="Voice",
        value="ef")
    ```


    :param str class_map_name: Class map name.
    :param str device: A device name from the provider configuration.
    :param str value: DSCP value.
    """
    ...
