# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetDhcpRelayAddressResult',
    'AwaitableGetDhcpRelayAddressResult',
    'get_dhcp_relay_address',
    'get_dhcp_relay_address_output',
]

@pulumi.output_type
class GetDhcpRelayAddressResult:
    """
    A collection of values returned by getDhcpRelayAddress.
    """
    def __init__(__self__, address=None, device=None, id=None, interface_id=None, vrf=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if interface_id and not isinstance(interface_id, str):
            raise TypeError("Expected argument 'interface_id' to be a str")
        pulumi.set(__self__, "interface_id", interface_id)
        if vrf and not isinstance(vrf, str):
            raise TypeError("Expected argument 'vrf' to be a str")
        pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        IPv4 or IPv6 address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> str:
        """
        Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        """
        return pulumi.get(self, "interface_id")

    @property
    @pulumi.getter
    def vrf(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")


class AwaitableGetDhcpRelayAddressResult(GetDhcpRelayAddressResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDhcpRelayAddressResult(
            address=self.address,
            device=self.device,
            id=self.id,
            interface_id=self.interface_id,
            vrf=self.vrf)


def get_dhcp_relay_address(address: Optional[str] = None,
                           device: Optional[str] = None,
                           interface_id: Optional[str] = None,
                           vrf: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDhcpRelayAddressResult:
    """
    This data source can read a DHCP relay address.

    - API Documentation: [dhcpRelayAddr](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/DHCP/dhcp:RelayAddr/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_dhcp_relay_address(address="1.1.1.1",
        interface_id="eth1/10",
        vrf="VRF1")
    ```


    :param str address: IPv4 or IPv6 address.
    :param str device: A device name from the provider configuration.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
    :param str vrf: VRF name.
    """
    __args__ = dict()
    __args__['address'] = address
    __args__['device'] = device
    __args__['interfaceId'] = interface_id
    __args__['vrf'] = vrf
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getDhcpRelayAddress:getDhcpRelayAddress', __args__, opts=opts, typ=GetDhcpRelayAddressResult).value

    return AwaitableGetDhcpRelayAddressResult(
        address=pulumi.get(__ret__, 'address'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        interface_id=pulumi.get(__ret__, 'interface_id'),
        vrf=pulumi.get(__ret__, 'vrf'))


@_utilities.lift_output_func(get_dhcp_relay_address)
def get_dhcp_relay_address_output(address: Optional[pulumi.Input[str]] = None,
                                  device: Optional[pulumi.Input[Optional[str]]] = None,
                                  interface_id: Optional[pulumi.Input[str]] = None,
                                  vrf: Optional[pulumi.Input[str]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDhcpRelayAddressResult]:
    """
    This data source can read a DHCP relay address.

    - API Documentation: [dhcpRelayAddr](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/DHCP/dhcp:RelayAddr/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_dhcp_relay_address(address="1.1.1.1",
        interface_id="eth1/10",
        vrf="VRF1")
    ```


    :param str address: IPv4 or IPv6 address.
    :param str device: A device name from the provider configuration.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
    :param str vrf: VRF name.
    """
    ...
