# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetEvpnVniResult',
    'AwaitableGetEvpnVniResult',
    'get_evpn_vni',
    'get_evpn_vni_output',
]

@pulumi.output_type
class GetEvpnVniResult:
    """
    A collection of values returned by getEvpnVni.
    """
    def __init__(__self__, device=None, encap=None, id=None, route_distinguisher=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if encap and not isinstance(encap, str):
            raise TypeError("Expected argument 'encap' to be a str")
        pulumi.set(__self__, "encap", encap)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if route_distinguisher and not isinstance(route_distinguisher, str):
            raise TypeError("Expected argument 'route_distinguisher' to be a str")
        pulumi.set(__self__, "route_distinguisher", route_distinguisher)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def encap(self) -> str:
        """
        Encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`.
        """
        return pulumi.get(self, "encap")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="routeDistinguisher")
    def route_distinguisher(self) -> str:
        """
        Route Distinguisher value in NX-OS DME format.
        """
        return pulumi.get(self, "route_distinguisher")


class AwaitableGetEvpnVniResult(GetEvpnVniResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEvpnVniResult(
            device=self.device,
            encap=self.encap,
            id=self.id,
            route_distinguisher=self.route_distinguisher)


def get_evpn_vni(device: Optional[str] = None,
                 encap: Optional[str] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEvpnVniResult:
    """
    This data source can read a EVPN VNI Route Distinguisher.

    - API Documentation: [rtctrlBDEvi](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtctrl:BDEvi/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_evpn_vni(encap="vxlan-123456")
    ```


    :param str device: A device name from the provider configuration.
    :param str encap: Encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`.
    """
    __args__ = dict()
    __args__['device'] = device
    __args__['encap'] = encap
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getEvpnVni:getEvpnVni', __args__, opts=opts, typ=GetEvpnVniResult).value

    return AwaitableGetEvpnVniResult(
        device=pulumi.get(__ret__, 'device'),
        encap=pulumi.get(__ret__, 'encap'),
        id=pulumi.get(__ret__, 'id'),
        route_distinguisher=pulumi.get(__ret__, 'route_distinguisher'))


@_utilities.lift_output_func(get_evpn_vni)
def get_evpn_vni_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                        encap: Optional[pulumi.Input[str]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetEvpnVniResult]:
    """
    This data source can read a EVPN VNI Route Distinguisher.

    - API Documentation: [rtctrlBDEvi](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtctrl:BDEvi/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_evpn_vni(encap="vxlan-123456")
    ```


    :param str device: A device name from the provider configuration.
    :param str encap: Encapsulation. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`.
    """
    ...
