# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetHmmInstanceResult',
    'AwaitableGetHmmInstanceResult',
    'get_hmm_instance',
    'get_hmm_instance_output',
]

@pulumi.output_type
class GetHmmInstanceResult:
    """
    A collection of values returned by getHmmInstance.
    """
    def __init__(__self__, admin_state=None, anycast_mac=None, device=None, id=None):
        if admin_state and not isinstance(admin_state, str):
            raise TypeError("Expected argument 'admin_state' to be a str")
        pulumi.set(__self__, "admin_state", admin_state)
        if anycast_mac and not isinstance(anycast_mac, str):
            raise TypeError("Expected argument 'anycast_mac' to be a str")
        pulumi.set(__self__, "anycast_mac", anycast_mac)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> str:
        """
        Administrative state.
        """
        return pulumi.get(self, "admin_state")

    @property
    @pulumi.getter(name="anycastMac")
    def anycast_mac(self) -> str:
        """
        Anycast Gateway MAC address.
        """
        return pulumi.get(self, "anycast_mac")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")


class AwaitableGetHmmInstanceResult(GetHmmInstanceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetHmmInstanceResult(
            admin_state=self.admin_state,
            anycast_mac=self.anycast_mac,
            device=self.device,
            id=self.id)


def get_hmm_instance(device: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetHmmInstanceResult:
    """
    This data source can read the HMM Fabric Forwarding Instance configuration.

    - API Documentation: [hmmFwdInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Host%20Mobility/hmm:FwdInst/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_hmm_instance()
    ```


    :param str device: A device name from the provider configuration.
    """
    __args__ = dict()
    __args__['device'] = device
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getHmmInstance:getHmmInstance', __args__, opts=opts, typ=GetHmmInstanceResult).value

    return AwaitableGetHmmInstanceResult(
        admin_state=pulumi.get(__ret__, 'admin_state'),
        anycast_mac=pulumi.get(__ret__, 'anycast_mac'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'))


@_utilities.lift_output_func(get_hmm_instance)
def get_hmm_instance_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetHmmInstanceResult]:
    """
    This data source can read the HMM Fabric Forwarding Instance configuration.

    - API Documentation: [hmmFwdInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Host%20Mobility/hmm:FwdInst/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_hmm_instance()
    ```


    :param str device: A device name from the provider configuration.
    """
    ...
