# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetIpv4InterfaceResult',
    'AwaitableGetIpv4InterfaceResult',
    'get_ipv4_interface',
    'get_ipv4_interface_output',
]

@pulumi.output_type
class GetIpv4InterfaceResult:
    """
    A collection of values returned by getIpv4Interface.
    """
    def __init__(__self__, device=None, drop_glean=None, forward=None, id=None, interface_id=None, unnumbered=None, urpf=None, vrf=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if drop_glean and not isinstance(drop_glean, str):
            raise TypeError("Expected argument 'drop_glean' to be a str")
        pulumi.set(__self__, "drop_glean", drop_glean)
        if forward and not isinstance(forward, str):
            raise TypeError("Expected argument 'forward' to be a str")
        pulumi.set(__self__, "forward", forward)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if interface_id and not isinstance(interface_id, str):
            raise TypeError("Expected argument 'interface_id' to be a str")
        pulumi.set(__self__, "interface_id", interface_id)
        if unnumbered and not isinstance(unnumbered, str):
            raise TypeError("Expected argument 'unnumbered' to be a str")
        pulumi.set(__self__, "unnumbered", unnumbered)
        if urpf and not isinstance(urpf, str):
            raise TypeError("Expected argument 'urpf' to be a str")
        pulumi.set(__self__, "urpf", urpf)
        if vrf and not isinstance(vrf, str):
            raise TypeError("Expected argument 'vrf' to be a str")
        pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="dropGlean")
    def drop_glean(self) -> str:
        """
        ip drop-glean enabled/disabled.
        """
        return pulumi.get(self, "drop_glean")

    @property
    @pulumi.getter
    def forward(self) -> str:
        """
        ip forward enabled/disabled.
        """
        return pulumi.get(self, "forward")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> str:
        """
        Must match first field in the output of `show intf brief`. Example: `eth1/1`.
        """
        return pulumi.get(self, "interface_id")

    @property
    @pulumi.getter
    def unnumbered(self) -> str:
        """
        IP unnumbered. Reference to interface must match first field in the output of `show intf brief`. Example: `eth1/1`.
        """
        return pulumi.get(self, "unnumbered")

    @property
    @pulumi.getter
    def urpf(self) -> str:
        """
        URPF (unicast Reverse Path Forwarding).
        """
        return pulumi.get(self, "urpf")

    @property
    @pulumi.getter
    def vrf(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")


class AwaitableGetIpv4InterfaceResult(GetIpv4InterfaceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIpv4InterfaceResult(
            device=self.device,
            drop_glean=self.drop_glean,
            forward=self.forward,
            id=self.id,
            interface_id=self.interface_id,
            unnumbered=self.unnumbered,
            urpf=self.urpf,
            vrf=self.vrf)


def get_ipv4_interface(device: Optional[str] = None,
                       interface_id: Optional[str] = None,
                       vrf: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIpv4InterfaceResult:
    """
    This data source can read an IPv4 interface.

    - API Documentation: [ipv4If](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%203/ipv4:If/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_ipv4_interface(interface_id="eth1/10",
        vrf="default")
    ```


    :param str device: A device name from the provider configuration.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
    :param str vrf: VRF name.
    """
    __args__ = dict()
    __args__['device'] = device
    __args__['interfaceId'] = interface_id
    __args__['vrf'] = vrf
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getIpv4Interface:getIpv4Interface', __args__, opts=opts, typ=GetIpv4InterfaceResult).value

    return AwaitableGetIpv4InterfaceResult(
        device=pulumi.get(__ret__, 'device'),
        drop_glean=pulumi.get(__ret__, 'drop_glean'),
        forward=pulumi.get(__ret__, 'forward'),
        id=pulumi.get(__ret__, 'id'),
        interface_id=pulumi.get(__ret__, 'interface_id'),
        unnumbered=pulumi.get(__ret__, 'unnumbered'),
        urpf=pulumi.get(__ret__, 'urpf'),
        vrf=pulumi.get(__ret__, 'vrf'))


@_utilities.lift_output_func(get_ipv4_interface)
def get_ipv4_interface_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                              interface_id: Optional[pulumi.Input[str]] = None,
                              vrf: Optional[pulumi.Input[str]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetIpv4InterfaceResult]:
    """
    This data source can read an IPv4 interface.

    - API Documentation: [ipv4If](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%203/ipv4:If/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_ipv4_interface(interface_id="eth1/10",
        vrf="default")
    ```


    :param str device: A device name from the provider configuration.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `eth1/1`.
    :param str vrf: VRF name.
    """
    ...
