# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPimAnycastRpPeerResult',
    'AwaitableGetPimAnycastRpPeerResult',
    'get_pim_anycast_rp_peer',
    'get_pim_anycast_rp_peer_output',
]

@pulumi.output_type
class GetPimAnycastRpPeerResult:
    """
    A collection of values returned by getPimAnycastRpPeer.
    """
    def __init__(__self__, address=None, device=None, id=None, rp_set_address=None, vrf_name=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if rp_set_address and not isinstance(rp_set_address, str):
            raise TypeError("Expected argument 'rp_set_address' to be a str")
        pulumi.set(__self__, "rp_set_address", rp_set_address)
        if vrf_name and not isinstance(vrf_name, str):
            raise TypeError("Expected argument 'vrf_name' to be a str")
        pulumi.set(__self__, "vrf_name", vrf_name)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Anycast RP address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="rpSetAddress")
    def rp_set_address(self) -> str:
        """
        RP set address.
        """
        return pulumi.get(self, "rp_set_address")

    @property
    @pulumi.getter(name="vrfName")
    def vrf_name(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf_name")


class AwaitableGetPimAnycastRpPeerResult(GetPimAnycastRpPeerResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPimAnycastRpPeerResult(
            address=self.address,
            device=self.device,
            id=self.id,
            rp_set_address=self.rp_set_address,
            vrf_name=self.vrf_name)


def get_pim_anycast_rp_peer(address: Optional[str] = None,
                            device: Optional[str] = None,
                            rp_set_address: Optional[str] = None,
                            vrf_name: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPimAnycastRpPeerResult:
    """
    This data source can read the PIM Anycast RP peer configuration.

    - API Documentation: [pimAcastRPPeer](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%203/pim:AcastRPPeer/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_pim_anycast_rp_peer(address="10.1.1.1/32",
        rp_set_address="20.1.1.1/32",
        vrf_name="default")
    ```


    :param str address: Anycast RP address.
    :param str device: A device name from the provider configuration.
    :param str rp_set_address: RP set address.
    :param str vrf_name: VRF name.
    """
    __args__ = dict()
    __args__['address'] = address
    __args__['device'] = device
    __args__['rpSetAddress'] = rp_set_address
    __args__['vrfName'] = vrf_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getPimAnycastRpPeer:getPimAnycastRpPeer', __args__, opts=opts, typ=GetPimAnycastRpPeerResult).value

    return AwaitableGetPimAnycastRpPeerResult(
        address=pulumi.get(__ret__, 'address'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        rp_set_address=pulumi.get(__ret__, 'rp_set_address'),
        vrf_name=pulumi.get(__ret__, 'vrf_name'))


@_utilities.lift_output_func(get_pim_anycast_rp_peer)
def get_pim_anycast_rp_peer_output(address: Optional[pulumi.Input[str]] = None,
                                   device: Optional[pulumi.Input[Optional[str]]] = None,
                                   rp_set_address: Optional[pulumi.Input[str]] = None,
                                   vrf_name: Optional[pulumi.Input[str]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPimAnycastRpPeerResult]:
    """
    This data source can read the PIM Anycast RP peer configuration.

    - API Documentation: [pimAcastRPPeer](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%203/pim:AcastRPPeer/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_pim_anycast_rp_peer(address="10.1.1.1/32",
        rp_set_address="20.1.1.1/32",
        vrf_name="default")
    ```


    :param str address: Anycast RP address.
    :param str device: A device name from the provider configuration.
    :param str rp_set_address: RP set address.
    :param str vrf_name: VRF name.
    """
    ...
