# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPimStaticRpGroupListResult',
    'AwaitableGetPimStaticRpGroupListResult',
    'get_pim_static_rp_group_list',
    'get_pim_static_rp_group_list_output',
]

@pulumi.output_type
class GetPimStaticRpGroupListResult:
    """
    A collection of values returned by getPimStaticRpGroupList.
    """
    def __init__(__self__, address=None, bidir=None, device=None, id=None, override=None, rp_address=None, vrf_name=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if bidir and not isinstance(bidir, bool):
            raise TypeError("Expected argument 'bidir' to be a bool")
        pulumi.set(__self__, "bidir", bidir)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if override and not isinstance(override, bool):
            raise TypeError("Expected argument 'override' to be a bool")
        pulumi.set(__self__, "override", override)
        if rp_address and not isinstance(rp_address, str):
            raise TypeError("Expected argument 'rp_address' to be a str")
        pulumi.set(__self__, "rp_address", rp_address)
        if vrf_name and not isinstance(vrf_name, str):
            raise TypeError("Expected argument 'vrf_name' to be a str")
        pulumi.set(__self__, "vrf_name", vrf_name)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Group list address information.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def bidir(self) -> bool:
        """
        Flag to treat Group Ranges as BiDir.
        """
        return pulumi.get(self, "bidir")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def override(self) -> bool:
        """
        Flag to override RP preference to use Static over Dynamic RP.
        """
        return pulumi.get(self, "override")

    @property
    @pulumi.getter(name="rpAddress")
    def rp_address(self) -> str:
        """
        RP address.
        """
        return pulumi.get(self, "rp_address")

    @property
    @pulumi.getter(name="vrfName")
    def vrf_name(self) -> str:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf_name")


class AwaitableGetPimStaticRpGroupListResult(GetPimStaticRpGroupListResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPimStaticRpGroupListResult(
            address=self.address,
            bidir=self.bidir,
            device=self.device,
            id=self.id,
            override=self.override,
            rp_address=self.rp_address,
            vrf_name=self.vrf_name)


def get_pim_static_rp_group_list(address: Optional[str] = None,
                                 device: Optional[str] = None,
                                 rp_address: Optional[str] = None,
                                 vrf_name: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPimStaticRpGroupListResult:
    """
    This data source can read the PIM Static RP group list configuration.

    - API Documentation: [pimRPGrpList](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%203/pim:RPGrpList/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_pim_static_rp_group_list(address="224.0.0.0/4",
        rp_address="1.2.3.4",
        vrf_name="default")
    ```


    :param str address: Group list address information.
    :param str device: A device name from the provider configuration.
    :param str rp_address: RP address.
    :param str vrf_name: VRF name.
    """
    __args__ = dict()
    __args__['address'] = address
    __args__['device'] = device
    __args__['rpAddress'] = rp_address
    __args__['vrfName'] = vrf_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getPimStaticRpGroupList:getPimStaticRpGroupList', __args__, opts=opts, typ=GetPimStaticRpGroupListResult).value

    return AwaitableGetPimStaticRpGroupListResult(
        address=pulumi.get(__ret__, 'address'),
        bidir=pulumi.get(__ret__, 'bidir'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        override=pulumi.get(__ret__, 'override'),
        rp_address=pulumi.get(__ret__, 'rp_address'),
        vrf_name=pulumi.get(__ret__, 'vrf_name'))


@_utilities.lift_output_func(get_pim_static_rp_group_list)
def get_pim_static_rp_group_list_output(address: Optional[pulumi.Input[str]] = None,
                                        device: Optional[pulumi.Input[Optional[str]]] = None,
                                        rp_address: Optional[pulumi.Input[str]] = None,
                                        vrf_name: Optional[pulumi.Input[str]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPimStaticRpGroupListResult]:
    """
    This data source can read the PIM Static RP group list configuration.

    - API Documentation: [pimRPGrpList](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Layer%203/pim:RPGrpList/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_pim_static_rp_group_list(address="224.0.0.0/4",
        rp_address="1.2.3.4",
        vrf_name="default")
    ```


    :param str address: Group list address information.
    :param str device: A device name from the provider configuration.
    :param str rp_address: RP address.
    :param str vrf_name: VRF name.
    """
    ...
