# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPortChannelInterfaceMemberResult',
    'AwaitableGetPortChannelInterfaceMemberResult',
    'get_port_channel_interface_member',
    'get_port_channel_interface_member_output',
]

@pulumi.output_type
class GetPortChannelInterfaceMemberResult:
    """
    A collection of values returned by getPortChannelInterfaceMember.
    """
    def __init__(__self__, device=None, id=None, interface_dn=None, interface_id=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if interface_dn and not isinstance(interface_dn, str):
            raise TypeError("Expected argument 'interface_dn' to be a str")
        pulumi.set(__self__, "interface_dn", interface_dn)
        if interface_id and not isinstance(interface_id, str):
            raise TypeError("Expected argument 'interface_id' to be a str")
        pulumi.set(__self__, "interface_id", interface_id)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="interfaceDn")
    def interface_dn(self) -> str:
        """
        DN of interface. For example: `sys/intf/phys-[eth1/1]`.
        """
        return pulumi.get(self, "interface_dn")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> str:
        """
        Must match first field in the output of `show intf brief`. Example: `po1`.
        """
        return pulumi.get(self, "interface_id")


class AwaitableGetPortChannelInterfaceMemberResult(GetPortChannelInterfaceMemberResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPortChannelInterfaceMemberResult(
            device=self.device,
            id=self.id,
            interface_dn=self.interface_dn,
            interface_id=self.interface_id)


def get_port_channel_interface_member(device: Optional[str] = None,
                                      interface_dn: Optional[str] = None,
                                      interface_id: Optional[str] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPortChannelInterfaceMemberResult:
    """
    This data source can read the configuration of a port-channel interface member.

    - API Documentation: [pcRsMbrIfs](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Interfaces/pc:RsMbrIfs/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_port_channel_interface_member(interface_dn="sys/intf/phys-[eth1/11]",
        interface_id="po1")
    ```


    :param str device: A device name from the provider configuration.
    :param str interface_dn: DN of interface. For example: `sys/intf/phys-[eth1/1]`.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
    """
    __args__ = dict()
    __args__['device'] = device
    __args__['interfaceDn'] = interface_dn
    __args__['interfaceId'] = interface_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getPortChannelInterfaceMember:getPortChannelInterfaceMember', __args__, opts=opts, typ=GetPortChannelInterfaceMemberResult).value

    return AwaitableGetPortChannelInterfaceMemberResult(
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        interface_dn=pulumi.get(__ret__, 'interface_dn'),
        interface_id=pulumi.get(__ret__, 'interface_id'))


@_utilities.lift_output_func(get_port_channel_interface_member)
def get_port_channel_interface_member_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                                             interface_dn: Optional[pulumi.Input[str]] = None,
                                             interface_id: Optional[pulumi.Input[str]] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPortChannelInterfaceMemberResult]:
    """
    This data source can read the configuration of a port-channel interface member.

    - API Documentation: [pcRsMbrIfs](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Interfaces/pc:RsMbrIfs/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_port_channel_interface_member(interface_dn="sys/intf/phys-[eth1/11]",
        interface_id="po1")
    ```


    :param str device: A device name from the provider configuration.
    :param str interface_dn: DN of interface. For example: `sys/intf/phys-[eth1/1]`.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
    """
    ...
