# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetPortChannelInterfaceVrfResult',
    'AwaitableGetPortChannelInterfaceVrfResult',
    'get_port_channel_interface_vrf',
    'get_port_channel_interface_vrf_output',
]

@pulumi.output_type
class GetPortChannelInterfaceVrfResult:
    """
    A collection of values returned by getPortChannelInterfaceVrf.
    """
    def __init__(__self__, device=None, id=None, interface_id=None, vrf_dn=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if interface_id and not isinstance(interface_id, str):
            raise TypeError("Expected argument 'interface_id' to be a str")
        pulumi.set(__self__, "interface_id", interface_id)
        if vrf_dn and not isinstance(vrf_dn, str):
            raise TypeError("Expected argument 'vrf_dn' to be a str")
        pulumi.set(__self__, "vrf_dn", vrf_dn)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> str:
        """
        Must match first field in the output of `show intf brief`. Example: `po1`.
        """
        return pulumi.get(self, "interface_id")

    @property
    @pulumi.getter(name="vrfDn")
    def vrf_dn(self) -> str:
        """
        DN of VRF. For example: `sys/inst-VRF1`.
        """
        return pulumi.get(self, "vrf_dn")


class AwaitableGetPortChannelInterfaceVrfResult(GetPortChannelInterfaceVrfResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPortChannelInterfaceVrfResult(
            device=self.device,
            id=self.id,
            interface_id=self.interface_id,
            vrf_dn=self.vrf_dn)


def get_port_channel_interface_vrf(device: Optional[str] = None,
                                   interface_id: Optional[str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPortChannelInterfaceVrfResult:
    """
    This data source can read a port-channel interface VRF association.

    - API Documentation: [nwRtVrfMbr](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/nw:RtVrfMbr/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_port_channel_interface_vrf(interface_id="po1")
    ```


    :param str device: A device name from the provider configuration.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
    """
    __args__ = dict()
    __args__['device'] = device
    __args__['interfaceId'] = interface_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getPortChannelInterfaceVrf:getPortChannelInterfaceVrf', __args__, opts=opts, typ=GetPortChannelInterfaceVrfResult).value

    return AwaitableGetPortChannelInterfaceVrfResult(
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        interface_id=pulumi.get(__ret__, 'interface_id'),
        vrf_dn=pulumi.get(__ret__, 'vrf_dn'))


@_utilities.lift_output_func(get_port_channel_interface_vrf)
def get_port_channel_interface_vrf_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                                          interface_id: Optional[pulumi.Input[str]] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPortChannelInterfaceVrfResult]:
    """
    This data source can read a port-channel interface VRF association.

    - API Documentation: [nwRtVrfMbr](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/nw:RtVrfMbr/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_port_channel_interface_vrf(interface_id="po1")
    ```


    :param str device: A device name from the provider configuration.
    :param str interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
    """
    ...
