# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetQueuingQosPolicySystemOutResult',
    'AwaitableGetQueuingQosPolicySystemOutResult',
    'get_queuing_qos_policy_system_out',
    'get_queuing_qos_policy_system_out_output',
]

@pulumi.output_type
class GetQueuingQosPolicySystemOutResult:
    """
    A collection of values returned by getQueuingQosPolicySystemOut.
    """
    def __init__(__self__, device=None, id=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")


class AwaitableGetQueuingQosPolicySystemOutResult(GetQueuingQosPolicySystemOutResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetQueuingQosPolicySystemOutResult(
            device=self.device,
            id=self.id)


def get_queuing_qos_policy_system_out(device: Optional[str] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetQueuingQosPolicySystemOutResult:
    """
    This data source can read the queuing QoS policy system out configuration.

    - API Documentation: [ipqosSystem](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:System/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_queuing_qos_policy_system_out()
    ```


    :param str device: A device name from the provider configuration.
    """
    __args__ = dict()
    __args__['device'] = device
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getQueuingQosPolicySystemOut:getQueuingQosPolicySystemOut', __args__, opts=opts, typ=GetQueuingQosPolicySystemOutResult).value

    return AwaitableGetQueuingQosPolicySystemOutResult(
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'))


@_utilities.lift_output_func(get_queuing_qos_policy_system_out)
def get_queuing_qos_policy_system_out_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetQueuingQosPolicySystemOutResult]:
    """
    This data source can read the queuing QoS policy system out configuration.

    - API Documentation: [ipqosSystem](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:System/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_queuing_qos_policy_system_out()
    ```


    :param str device: A device name from the provider configuration.
    """
    ...
