# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetQueuingQosPolicySystemOutPolicyMapResult',
    'AwaitableGetQueuingQosPolicySystemOutPolicyMapResult',
    'get_queuing_qos_policy_system_out_policy_map',
    'get_queuing_qos_policy_system_out_policy_map_output',
]

@pulumi.output_type
class GetQueuingQosPolicySystemOutPolicyMapResult:
    """
    A collection of values returned by getQueuingQosPolicySystemOutPolicyMap.
    """
    def __init__(__self__, device=None, id=None, policy_map_name=None):
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if policy_map_name and not isinstance(policy_map_name, str):
            raise TypeError("Expected argument 'policy_map_name' to be a str")
        pulumi.set(__self__, "policy_map_name", policy_map_name)

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="policyMapName")
    def policy_map_name(self) -> str:
        """
        Policy map name.
        """
        return pulumi.get(self, "policy_map_name")


class AwaitableGetQueuingQosPolicySystemOutPolicyMapResult(GetQueuingQosPolicySystemOutPolicyMapResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetQueuingQosPolicySystemOutPolicyMapResult(
            device=self.device,
            id=self.id,
            policy_map_name=self.policy_map_name)


def get_queuing_qos_policy_system_out_policy_map(device: Optional[str] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetQueuingQosPolicySystemOutPolicyMapResult:
    """
    This data source can read the queuing QoS policy system out policy map configuration.

    - API Documentation: [ipqosInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:Inst/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_queuing_qos_policy_system_out_policy_map()
    ```


    :param str device: A device name from the provider configuration.
    """
    __args__ = dict()
    __args__['device'] = device
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getQueuingQosPolicySystemOutPolicyMap:getQueuingQosPolicySystemOutPolicyMap', __args__, opts=opts, typ=GetQueuingQosPolicySystemOutPolicyMapResult).value

    return AwaitableGetQueuingQosPolicySystemOutPolicyMapResult(
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        policy_map_name=pulumi.get(__ret__, 'policy_map_name'))


@_utilities.lift_output_func(get_queuing_qos_policy_system_out_policy_map)
def get_queuing_qos_policy_system_out_policy_map_output(device: Optional[pulumi.Input[Optional[str]]] = None,
                                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetQueuingQosPolicySystemOutPolicyMapResult]:
    """
    This data source can read the queuing QoS policy system out policy map configuration.

    - API Documentation: [ipqosInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Qos/ipqos:Inst/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_queuing_qos_policy_system_out_policy_map()
    ```


    :param str device: A device name from the provider configuration.
    """
    ...
