# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetRouteMapRuleEntrySetRegularCommunityItemResult',
    'AwaitableGetRouteMapRuleEntrySetRegularCommunityItemResult',
    'get_route_map_rule_entry_set_regular_community_item',
    'get_route_map_rule_entry_set_regular_community_item_output',
]

@pulumi.output_type
class GetRouteMapRuleEntrySetRegularCommunityItemResult:
    """
    A collection of values returned by getRouteMapRuleEntrySetRegularCommunityItem.
    """
    def __init__(__self__, community=None, device=None, id=None, order=None, rule_name=None):
        if community and not isinstance(community, str):
            raise TypeError("Expected argument 'community' to be a str")
        pulumi.set(__self__, "community", community)
        if device and not isinstance(device, str):
            raise TypeError("Expected argument 'device' to be a str")
        pulumi.set(__self__, "device", device)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if order and not isinstance(order, int):
            raise TypeError("Expected argument 'order' to be a int")
        pulumi.set(__self__, "order", order)
        if rule_name and not isinstance(rule_name, str):
            raise TypeError("Expected argument 'rule_name' to be a str")
        pulumi.set(__self__, "rule_name", rule_name)

    @property
    @pulumi.getter
    def community(self) -> str:
        """
        Set Community.
        """
        return pulumi.get(self, "community")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The distinguished name of the object.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def order(self) -> int:
        """
        Route-Map Rule Entry order.
        """
        return pulumi.get(self, "order")

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> str:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")


class AwaitableGetRouteMapRuleEntrySetRegularCommunityItemResult(GetRouteMapRuleEntrySetRegularCommunityItemResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRouteMapRuleEntrySetRegularCommunityItemResult(
            community=self.community,
            device=self.device,
            id=self.id,
            order=self.order,
            rule_name=self.rule_name)


def get_route_map_rule_entry_set_regular_community_item(community: Optional[str] = None,
                                                        device: Optional[str] = None,
                                                        order: Optional[int] = None,
                                                        rule_name: Optional[str] = None,
                                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRouteMapRuleEntrySetRegularCommunityItemResult:
    """
    This data source can read a Set Community item in a Route-Map Rule Entry.

    - API Documentation: [rtregcomItem](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtregcom:Item/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_route_map_rule_entry_set_regular_community_item(community="regular:as2-nn2:65001:123",
        order=10,
        rule_name="RULE1")
    ```


    :param str community: Set Community.
    :param str device: A device name from the provider configuration.
    :param int order: Route-Map Rule Entry order.
    :param str rule_name: Route Map rule name.
    """
    __args__ = dict()
    __args__['community'] = community
    __args__['device'] = device
    __args__['order'] = order
    __args__['ruleName'] = rule_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nxos:index/getRouteMapRuleEntrySetRegularCommunityItem:getRouteMapRuleEntrySetRegularCommunityItem', __args__, opts=opts, typ=GetRouteMapRuleEntrySetRegularCommunityItemResult).value

    return AwaitableGetRouteMapRuleEntrySetRegularCommunityItemResult(
        community=pulumi.get(__ret__, 'community'),
        device=pulumi.get(__ret__, 'device'),
        id=pulumi.get(__ret__, 'id'),
        order=pulumi.get(__ret__, 'order'),
        rule_name=pulumi.get(__ret__, 'rule_name'))


@_utilities.lift_output_func(get_route_map_rule_entry_set_regular_community_item)
def get_route_map_rule_entry_set_regular_community_item_output(community: Optional[pulumi.Input[str]] = None,
                                                               device: Optional[pulumi.Input[Optional[str]]] = None,
                                                               order: Optional[pulumi.Input[int]] = None,
                                                               rule_name: Optional[pulumi.Input[str]] = None,
                                                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRouteMapRuleEntrySetRegularCommunityItemResult]:
    """
    This data source can read a Set Community item in a Route-Map Rule Entry.

    - API Documentation: [rtregcomItem](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtregcom:Item/)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nxos as nxos

    example = nxos.get_route_map_rule_entry_set_regular_community_item(community="regular:as2-nn2:65001:123",
        order=10,
        rule_name="RULE1")
    ```


    :param str community: Set Community.
    :param str device: A device name from the provider configuration.
    :param int order: Route-Map Rule Entry order.
    :param str rule_name: Route Map rule name.
    """
    ...
