# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['HmmInstanceArgs', 'HmmInstance']

@pulumi.input_type
class HmmInstanceArgs:
    def __init__(__self__, *,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 anycast_mac: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a HmmInstance resource.
        :param pulumi.Input[str] admin_state: Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        :param pulumi.Input[str] anycast_mac: Anycast Gateway MAC address. - Default value: `enabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        if admin_state is not None:
            pulumi.set(__self__, "admin_state", admin_state)
        if anycast_mac is not None:
            pulumi.set(__self__, "anycast_mac", anycast_mac)
        if device is not None:
            pulumi.set(__self__, "device", device)

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        """
        return pulumi.get(self, "admin_state")

    @admin_state.setter
    def admin_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_state", value)

    @property
    @pulumi.getter(name="anycastMac")
    def anycast_mac(self) -> Optional[pulumi.Input[str]]:
        """
        Anycast Gateway MAC address. - Default value: `enabled`
        """
        return pulumi.get(self, "anycast_mac")

    @anycast_mac.setter
    def anycast_mac(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "anycast_mac", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)


@pulumi.input_type
class _HmmInstanceState:
    def __init__(__self__, *,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 anycast_mac: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering HmmInstance resources.
        :param pulumi.Input[str] admin_state: Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        :param pulumi.Input[str] anycast_mac: Anycast Gateway MAC address. - Default value: `enabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        if admin_state is not None:
            pulumi.set(__self__, "admin_state", admin_state)
        if anycast_mac is not None:
            pulumi.set(__self__, "anycast_mac", anycast_mac)
        if device is not None:
            pulumi.set(__self__, "device", device)

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        """
        return pulumi.get(self, "admin_state")

    @admin_state.setter
    def admin_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_state", value)

    @property
    @pulumi.getter(name="anycastMac")
    def anycast_mac(self) -> Optional[pulumi.Input[str]]:
        """
        Anycast Gateway MAC address. - Default value: `enabled`
        """
        return pulumi.get(self, "anycast_mac")

    @anycast_mac.setter
    def anycast_mac(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "anycast_mac", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)


class HmmInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 anycast_mac: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage the HMM Fabric Forwarding Instance configuration.

        - API Documentation: [hmmFwdInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Host%20Mobility/hmm:FwdInst/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.HmmInstance("example",
            admin_state="enabled",
            anycast_mac="20:20:00:00:10:10")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/hmmInstance:HmmInstance example "sys/hmm/fwdinst"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] admin_state: Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        :param pulumi.Input[str] anycast_mac: Anycast Gateway MAC address. - Default value: `enabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[HmmInstanceArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the HMM Fabric Forwarding Instance configuration.

        - API Documentation: [hmmFwdInst](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Host%20Mobility/hmm:FwdInst/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.HmmInstance("example",
            admin_state="enabled",
            anycast_mac="20:20:00:00:10:10")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/hmmInstance:HmmInstance example "sys/hmm/fwdinst"
        ```

        :param str resource_name: The name of the resource.
        :param HmmInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(HmmInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 anycast_mac: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = HmmInstanceArgs.__new__(HmmInstanceArgs)

            __props__.__dict__["admin_state"] = admin_state
            __props__.__dict__["anycast_mac"] = anycast_mac
            __props__.__dict__["device"] = device
        super(HmmInstance, __self__).__init__(
            'nxos:index/hmmInstance:HmmInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            admin_state: Optional[pulumi.Input[str]] = None,
            anycast_mac: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None) -> 'HmmInstance':
        """
        Get an existing HmmInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] admin_state: Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        :param pulumi.Input[str] anycast_mac: Anycast Gateway MAC address. - Default value: `enabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _HmmInstanceState.__new__(_HmmInstanceState)

        __props__.__dict__["admin_state"] = admin_state
        __props__.__dict__["anycast_mac"] = anycast_mac
        __props__.__dict__["device"] = device
        return HmmInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> pulumi.Output[str]:
        """
        Administrative state. - Choices: `enabled`, `disabled` - Default value: `enabled`
        """
        return pulumi.get(self, "admin_state")

    @property
    @pulumi.getter(name="anycastMac")
    def anycast_mac(self) -> pulumi.Output[str]:
        """
        Anycast Gateway MAC address. - Default value: `enabled`
        """
        return pulumi.get(self, "anycast_mac")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

