# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['PortChannelInterfaceArgs', 'PortChannelInterface']

@pulumi.input_type
class PortChannelInterfaceArgs:
    def __init__(__self__, *,
                 interface_id: pulumi.Input[str],
                 access_vlan: Optional[pulumi.Input[str]] = None,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 auto_negotiation: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[int]] = None,
                 delay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 duplex: Optional[pulumi.Input[str]] = None,
                 layer: Optional[pulumi.Input[str]] = None,
                 link_logging: Optional[pulumi.Input[str]] = None,
                 maximum_links: Optional[pulumi.Input[int]] = None,
                 medium: Optional[pulumi.Input[str]] = None,
                 minimum_links: Optional[pulumi.Input[int]] = None,
                 mode: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 native_vlan: Optional[pulumi.Input[str]] = None,
                 port_channel_mode: Optional[pulumi.Input[str]] = None,
                 speed: Optional[pulumi.Input[str]] = None,
                 suspend_individual: Optional[pulumi.Input[str]] = None,
                 trunk_vlans: Optional[pulumi.Input[str]] = None,
                 user_configured_flags: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a PortChannelInterface resource.
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
        :param pulumi.Input[str] access_vlan: Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] admin_state: Administrative port state. - Choices: `up`, `down` - Default value: `up`
        :param pulumi.Input[str] auto_negotiation: Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        :param pulumi.Input[int] bandwidth: The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
               value: `0`
        :param pulumi.Input[int] delay: The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        :param pulumi.Input[str] description: Interface description.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] duplex: Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        :param pulumi.Input[str] layer: Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        :param pulumi.Input[str] link_logging: Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        :param pulumi.Input[int] maximum_links: Maximum links. - Range: `1`-`32` - Default value: `32`
        :param pulumi.Input[str] medium: The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        :param pulumi.Input[int] minimum_links: Minimum links. - Range: `1`-`32` - Default value: `1`
        :param pulumi.Input[str] mode: Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
               `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        :param pulumi.Input[int] mtu: Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        :param pulumi.Input[str] native_vlan: Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] port_channel_mode: The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
               value: `on`
        :param pulumi.Input[str] speed: Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
               `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
               `auto`
        :param pulumi.Input[str] suspend_individual: Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        :param pulumi.Input[str] trunk_vlans: List of trunk VLANs. - Default value: `1-4094`
        :param pulumi.Input[str] user_configured_flags: Port User Config Flags.
        """
        pulumi.set(__self__, "interface_id", interface_id)
        if access_vlan is not None:
            pulumi.set(__self__, "access_vlan", access_vlan)
        if admin_state is not None:
            pulumi.set(__self__, "admin_state", admin_state)
        if auto_negotiation is not None:
            pulumi.set(__self__, "auto_negotiation", auto_negotiation)
        if bandwidth is not None:
            pulumi.set(__self__, "bandwidth", bandwidth)
        if delay is not None:
            pulumi.set(__self__, "delay", delay)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if duplex is not None:
            pulumi.set(__self__, "duplex", duplex)
        if layer is not None:
            pulumi.set(__self__, "layer", layer)
        if link_logging is not None:
            pulumi.set(__self__, "link_logging", link_logging)
        if maximum_links is not None:
            pulumi.set(__self__, "maximum_links", maximum_links)
        if medium is not None:
            pulumi.set(__self__, "medium", medium)
        if minimum_links is not None:
            pulumi.set(__self__, "minimum_links", minimum_links)
        if mode is not None:
            pulumi.set(__self__, "mode", mode)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)
        if native_vlan is not None:
            pulumi.set(__self__, "native_vlan", native_vlan)
        if port_channel_mode is not None:
            pulumi.set(__self__, "port_channel_mode", port_channel_mode)
        if speed is not None:
            pulumi.set(__self__, "speed", speed)
        if suspend_individual is not None:
            pulumi.set(__self__, "suspend_individual", suspend_individual)
        if trunk_vlans is not None:
            pulumi.set(__self__, "trunk_vlans", trunk_vlans)
        if user_configured_flags is not None:
            pulumi.set(__self__, "user_configured_flags", user_configured_flags)

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> pulumi.Input[str]:
        """
        Must match first field in the output of `show intf brief`. Example: `po1`.
        """
        return pulumi.get(self, "interface_id")

    @interface_id.setter
    def interface_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "interface_id", value)

    @property
    @pulumi.getter(name="accessVlan")
    def access_vlan(self) -> Optional[pulumi.Input[str]]:
        """
        Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        """
        return pulumi.get(self, "access_vlan")

    @access_vlan.setter
    def access_vlan(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_vlan", value)

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port state. - Choices: `up`, `down` - Default value: `up`
        """
        return pulumi.get(self, "admin_state")

    @admin_state.setter
    def admin_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_state", value)

    @property
    @pulumi.getter(name="autoNegotiation")
    def auto_negotiation(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        """
        return pulumi.get(self, "auto_negotiation")

    @auto_negotiation.setter
    def auto_negotiation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_negotiation", value)

    @property
    @pulumi.getter
    def bandwidth(self) -> Optional[pulumi.Input[int]]:
        """
        The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
        value: `0`
        """
        return pulumi.get(self, "bandwidth")

    @bandwidth.setter
    def bandwidth(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "bandwidth", value)

    @property
    @pulumi.getter
    def delay(self) -> Optional[pulumi.Input[int]]:
        """
        The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        """
        return pulumi.get(self, "delay")

    @delay.setter
    def delay(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "delay", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Interface description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def duplex(self) -> Optional[pulumi.Input[str]]:
        """
        Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        """
        return pulumi.get(self, "duplex")

    @duplex.setter
    def duplex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "duplex", value)

    @property
    @pulumi.getter
    def layer(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        """
        return pulumi.get(self, "layer")

    @layer.setter
    def layer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "layer", value)

    @property
    @pulumi.getter(name="linkLogging")
    def link_logging(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        """
        return pulumi.get(self, "link_logging")

    @link_logging.setter
    def link_logging(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "link_logging", value)

    @property
    @pulumi.getter(name="maximumLinks")
    def maximum_links(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum links. - Range: `1`-`32` - Default value: `32`
        """
        return pulumi.get(self, "maximum_links")

    @maximum_links.setter
    def maximum_links(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "maximum_links", value)

    @property
    @pulumi.getter
    def medium(self) -> Optional[pulumi.Input[str]]:
        """
        The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        """
        return pulumi.get(self, "medium")

    @medium.setter
    def medium(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "medium", value)

    @property
    @pulumi.getter(name="minimumLinks")
    def minimum_links(self) -> Optional[pulumi.Input[int]]:
        """
        Minimum links. - Range: `1`-`32` - Default value: `1`
        """
        return pulumi.get(self, "minimum_links")

    @minimum_links.setter
    def minimum_links(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "minimum_links", value)

    @property
    @pulumi.getter
    def mode(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
        `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        """
        return pulumi.get(self, "mode")

    @mode.setter
    def mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mode", value)

    @property
    @pulumi.getter
    def mtu(self) -> Optional[pulumi.Input[int]]:
        """
        Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        """
        return pulumi.get(self, "mtu")

    @mtu.setter
    def mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mtu", value)

    @property
    @pulumi.getter(name="nativeVlan")
    def native_vlan(self) -> Optional[pulumi.Input[str]]:
        """
        Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        """
        return pulumi.get(self, "native_vlan")

    @native_vlan.setter
    def native_vlan(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "native_vlan", value)

    @property
    @pulumi.getter(name="portChannelMode")
    def port_channel_mode(self) -> Optional[pulumi.Input[str]]:
        """
        The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
        value: `on`
        """
        return pulumi.get(self, "port_channel_mode")

    @port_channel_mode.setter
    def port_channel_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port_channel_mode", value)

    @property
    @pulumi.getter
    def speed(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
        `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
        `auto`
        """
        return pulumi.get(self, "speed")

    @speed.setter
    def speed(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "speed", value)

    @property
    @pulumi.getter(name="suspendIndividual")
    def suspend_individual(self) -> Optional[pulumi.Input[str]]:
        """
        Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        """
        return pulumi.get(self, "suspend_individual")

    @suspend_individual.setter
    def suspend_individual(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "suspend_individual", value)

    @property
    @pulumi.getter(name="trunkVlans")
    def trunk_vlans(self) -> Optional[pulumi.Input[str]]:
        """
        List of trunk VLANs. - Default value: `1-4094`
        """
        return pulumi.get(self, "trunk_vlans")

    @trunk_vlans.setter
    def trunk_vlans(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "trunk_vlans", value)

    @property
    @pulumi.getter(name="userConfiguredFlags")
    def user_configured_flags(self) -> Optional[pulumi.Input[str]]:
        """
        Port User Config Flags.
        """
        return pulumi.get(self, "user_configured_flags")

    @user_configured_flags.setter
    def user_configured_flags(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_configured_flags", value)


@pulumi.input_type
class _PortChannelInterfaceState:
    def __init__(__self__, *,
                 access_vlan: Optional[pulumi.Input[str]] = None,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 auto_negotiation: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[int]] = None,
                 delay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 duplex: Optional[pulumi.Input[str]] = None,
                 interface_id: Optional[pulumi.Input[str]] = None,
                 layer: Optional[pulumi.Input[str]] = None,
                 link_logging: Optional[pulumi.Input[str]] = None,
                 maximum_links: Optional[pulumi.Input[int]] = None,
                 medium: Optional[pulumi.Input[str]] = None,
                 minimum_links: Optional[pulumi.Input[int]] = None,
                 mode: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 native_vlan: Optional[pulumi.Input[str]] = None,
                 port_channel_mode: Optional[pulumi.Input[str]] = None,
                 speed: Optional[pulumi.Input[str]] = None,
                 suspend_individual: Optional[pulumi.Input[str]] = None,
                 trunk_vlans: Optional[pulumi.Input[str]] = None,
                 user_configured_flags: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering PortChannelInterface resources.
        :param pulumi.Input[str] access_vlan: Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] admin_state: Administrative port state. - Choices: `up`, `down` - Default value: `up`
        :param pulumi.Input[str] auto_negotiation: Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        :param pulumi.Input[int] bandwidth: The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
               value: `0`
        :param pulumi.Input[int] delay: The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        :param pulumi.Input[str] description: Interface description.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] duplex: Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
        :param pulumi.Input[str] layer: Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        :param pulumi.Input[str] link_logging: Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        :param pulumi.Input[int] maximum_links: Maximum links. - Range: `1`-`32` - Default value: `32`
        :param pulumi.Input[str] medium: The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        :param pulumi.Input[int] minimum_links: Minimum links. - Range: `1`-`32` - Default value: `1`
        :param pulumi.Input[str] mode: Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
               `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        :param pulumi.Input[int] mtu: Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        :param pulumi.Input[str] native_vlan: Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] port_channel_mode: The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
               value: `on`
        :param pulumi.Input[str] speed: Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
               `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
               `auto`
        :param pulumi.Input[str] suspend_individual: Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        :param pulumi.Input[str] trunk_vlans: List of trunk VLANs. - Default value: `1-4094`
        :param pulumi.Input[str] user_configured_flags: Port User Config Flags.
        """
        if access_vlan is not None:
            pulumi.set(__self__, "access_vlan", access_vlan)
        if admin_state is not None:
            pulumi.set(__self__, "admin_state", admin_state)
        if auto_negotiation is not None:
            pulumi.set(__self__, "auto_negotiation", auto_negotiation)
        if bandwidth is not None:
            pulumi.set(__self__, "bandwidth", bandwidth)
        if delay is not None:
            pulumi.set(__self__, "delay", delay)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if duplex is not None:
            pulumi.set(__self__, "duplex", duplex)
        if interface_id is not None:
            pulumi.set(__self__, "interface_id", interface_id)
        if layer is not None:
            pulumi.set(__self__, "layer", layer)
        if link_logging is not None:
            pulumi.set(__self__, "link_logging", link_logging)
        if maximum_links is not None:
            pulumi.set(__self__, "maximum_links", maximum_links)
        if medium is not None:
            pulumi.set(__self__, "medium", medium)
        if minimum_links is not None:
            pulumi.set(__self__, "minimum_links", minimum_links)
        if mode is not None:
            pulumi.set(__self__, "mode", mode)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)
        if native_vlan is not None:
            pulumi.set(__self__, "native_vlan", native_vlan)
        if port_channel_mode is not None:
            pulumi.set(__self__, "port_channel_mode", port_channel_mode)
        if speed is not None:
            pulumi.set(__self__, "speed", speed)
        if suspend_individual is not None:
            pulumi.set(__self__, "suspend_individual", suspend_individual)
        if trunk_vlans is not None:
            pulumi.set(__self__, "trunk_vlans", trunk_vlans)
        if user_configured_flags is not None:
            pulumi.set(__self__, "user_configured_flags", user_configured_flags)

    @property
    @pulumi.getter(name="accessVlan")
    def access_vlan(self) -> Optional[pulumi.Input[str]]:
        """
        Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        """
        return pulumi.get(self, "access_vlan")

    @access_vlan.setter
    def access_vlan(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_vlan", value)

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port state. - Choices: `up`, `down` - Default value: `up`
        """
        return pulumi.get(self, "admin_state")

    @admin_state.setter
    def admin_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_state", value)

    @property
    @pulumi.getter(name="autoNegotiation")
    def auto_negotiation(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        """
        return pulumi.get(self, "auto_negotiation")

    @auto_negotiation.setter
    def auto_negotiation(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_negotiation", value)

    @property
    @pulumi.getter
    def bandwidth(self) -> Optional[pulumi.Input[int]]:
        """
        The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
        value: `0`
        """
        return pulumi.get(self, "bandwidth")

    @bandwidth.setter
    def bandwidth(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "bandwidth", value)

    @property
    @pulumi.getter
    def delay(self) -> Optional[pulumi.Input[int]]:
        """
        The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        """
        return pulumi.get(self, "delay")

    @delay.setter
    def delay(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "delay", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Interface description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def duplex(self) -> Optional[pulumi.Input[str]]:
        """
        Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        """
        return pulumi.get(self, "duplex")

    @duplex.setter
    def duplex(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "duplex", value)

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> Optional[pulumi.Input[str]]:
        """
        Must match first field in the output of `show intf brief`. Example: `po1`.
        """
        return pulumi.get(self, "interface_id")

    @interface_id.setter
    def interface_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "interface_id", value)

    @property
    @pulumi.getter
    def layer(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        """
        return pulumi.get(self, "layer")

    @layer.setter
    def layer(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "layer", value)

    @property
    @pulumi.getter(name="linkLogging")
    def link_logging(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        """
        return pulumi.get(self, "link_logging")

    @link_logging.setter
    def link_logging(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "link_logging", value)

    @property
    @pulumi.getter(name="maximumLinks")
    def maximum_links(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum links. - Range: `1`-`32` - Default value: `32`
        """
        return pulumi.get(self, "maximum_links")

    @maximum_links.setter
    def maximum_links(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "maximum_links", value)

    @property
    @pulumi.getter
    def medium(self) -> Optional[pulumi.Input[str]]:
        """
        The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        """
        return pulumi.get(self, "medium")

    @medium.setter
    def medium(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "medium", value)

    @property
    @pulumi.getter(name="minimumLinks")
    def minimum_links(self) -> Optional[pulumi.Input[int]]:
        """
        Minimum links. - Range: `1`-`32` - Default value: `1`
        """
        return pulumi.get(self, "minimum_links")

    @minimum_links.setter
    def minimum_links(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "minimum_links", value)

    @property
    @pulumi.getter
    def mode(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
        `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        """
        return pulumi.get(self, "mode")

    @mode.setter
    def mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mode", value)

    @property
    @pulumi.getter
    def mtu(self) -> Optional[pulumi.Input[int]]:
        """
        Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        """
        return pulumi.get(self, "mtu")

    @mtu.setter
    def mtu(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mtu", value)

    @property
    @pulumi.getter(name="nativeVlan")
    def native_vlan(self) -> Optional[pulumi.Input[str]]:
        """
        Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        """
        return pulumi.get(self, "native_vlan")

    @native_vlan.setter
    def native_vlan(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "native_vlan", value)

    @property
    @pulumi.getter(name="portChannelMode")
    def port_channel_mode(self) -> Optional[pulumi.Input[str]]:
        """
        The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
        value: `on`
        """
        return pulumi.get(self, "port_channel_mode")

    @port_channel_mode.setter
    def port_channel_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port_channel_mode", value)

    @property
    @pulumi.getter
    def speed(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
        `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
        `auto`
        """
        return pulumi.get(self, "speed")

    @speed.setter
    def speed(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "speed", value)

    @property
    @pulumi.getter(name="suspendIndividual")
    def suspend_individual(self) -> Optional[pulumi.Input[str]]:
        """
        Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        """
        return pulumi.get(self, "suspend_individual")

    @suspend_individual.setter
    def suspend_individual(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "suspend_individual", value)

    @property
    @pulumi.getter(name="trunkVlans")
    def trunk_vlans(self) -> Optional[pulumi.Input[str]]:
        """
        List of trunk VLANs. - Default value: `1-4094`
        """
        return pulumi.get(self, "trunk_vlans")

    @trunk_vlans.setter
    def trunk_vlans(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "trunk_vlans", value)

    @property
    @pulumi.getter(name="userConfiguredFlags")
    def user_configured_flags(self) -> Optional[pulumi.Input[str]]:
        """
        Port User Config Flags.
        """
        return pulumi.get(self, "user_configured_flags")

    @user_configured_flags.setter
    def user_configured_flags(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_configured_flags", value)


class PortChannelInterface(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_vlan: Optional[pulumi.Input[str]] = None,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 auto_negotiation: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[int]] = None,
                 delay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 duplex: Optional[pulumi.Input[str]] = None,
                 interface_id: Optional[pulumi.Input[str]] = None,
                 layer: Optional[pulumi.Input[str]] = None,
                 link_logging: Optional[pulumi.Input[str]] = None,
                 maximum_links: Optional[pulumi.Input[int]] = None,
                 medium: Optional[pulumi.Input[str]] = None,
                 minimum_links: Optional[pulumi.Input[int]] = None,
                 mode: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 native_vlan: Optional[pulumi.Input[str]] = None,
                 port_channel_mode: Optional[pulumi.Input[str]] = None,
                 speed: Optional[pulumi.Input[str]] = None,
                 suspend_individual: Optional[pulumi.Input[str]] = None,
                 trunk_vlans: Optional[pulumi.Input[str]] = None,
                 user_configured_flags: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a port-channel interface.

        - API Documentation: [pcAggrIf](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Interfaces/pc:AggrIf/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.PortChannelInterface("example",
            access_vlan="vlan-1",
            admin_state="up",
            auto_negotiation="on",
            bandwidth=0,
            delay=1,
            description="My Description",
            duplex="auto",
            interface_id="po1",
            layer="Layer2",
            link_logging="enable",
            maximum_links=10,
            medium="broadcast",
            minimum_links=2,
            mode="access",
            mtu=1500,
            native_vlan="unknown",
            port_channel_mode="active",
            speed="auto",
            suspend_individual="disable",
            trunk_vlans="1-4094",
            user_configured_flags="admin_layer,admin_mtu,admin_state")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/portChannelInterface:PortChannelInterface example "sys/intf/aggr-[po1]"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_vlan: Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] admin_state: Administrative port state. - Choices: `up`, `down` - Default value: `up`
        :param pulumi.Input[str] auto_negotiation: Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        :param pulumi.Input[int] bandwidth: The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
               value: `0`
        :param pulumi.Input[int] delay: The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        :param pulumi.Input[str] description: Interface description.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] duplex: Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
        :param pulumi.Input[str] layer: Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        :param pulumi.Input[str] link_logging: Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        :param pulumi.Input[int] maximum_links: Maximum links. - Range: `1`-`32` - Default value: `32`
        :param pulumi.Input[str] medium: The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        :param pulumi.Input[int] minimum_links: Minimum links. - Range: `1`-`32` - Default value: `1`
        :param pulumi.Input[str] mode: Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
               `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        :param pulumi.Input[int] mtu: Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        :param pulumi.Input[str] native_vlan: Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] port_channel_mode: The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
               value: `on`
        :param pulumi.Input[str] speed: Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
               `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
               `auto`
        :param pulumi.Input[str] suspend_individual: Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        :param pulumi.Input[str] trunk_vlans: List of trunk VLANs. - Default value: `1-4094`
        :param pulumi.Input[str] user_configured_flags: Port User Config Flags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PortChannelInterfaceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a port-channel interface.

        - API Documentation: [pcAggrIf](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Interfaces/pc:AggrIf/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.PortChannelInterface("example",
            access_vlan="vlan-1",
            admin_state="up",
            auto_negotiation="on",
            bandwidth=0,
            delay=1,
            description="My Description",
            duplex="auto",
            interface_id="po1",
            layer="Layer2",
            link_logging="enable",
            maximum_links=10,
            medium="broadcast",
            minimum_links=2,
            mode="access",
            mtu=1500,
            native_vlan="unknown",
            port_channel_mode="active",
            speed="auto",
            suspend_individual="disable",
            trunk_vlans="1-4094",
            user_configured_flags="admin_layer,admin_mtu,admin_state")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/portChannelInterface:PortChannelInterface example "sys/intf/aggr-[po1]"
        ```

        :param str resource_name: The name of the resource.
        :param PortChannelInterfaceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PortChannelInterfaceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_vlan: Optional[pulumi.Input[str]] = None,
                 admin_state: Optional[pulumi.Input[str]] = None,
                 auto_negotiation: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[int]] = None,
                 delay: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 duplex: Optional[pulumi.Input[str]] = None,
                 interface_id: Optional[pulumi.Input[str]] = None,
                 layer: Optional[pulumi.Input[str]] = None,
                 link_logging: Optional[pulumi.Input[str]] = None,
                 maximum_links: Optional[pulumi.Input[int]] = None,
                 medium: Optional[pulumi.Input[str]] = None,
                 minimum_links: Optional[pulumi.Input[int]] = None,
                 mode: Optional[pulumi.Input[str]] = None,
                 mtu: Optional[pulumi.Input[int]] = None,
                 native_vlan: Optional[pulumi.Input[str]] = None,
                 port_channel_mode: Optional[pulumi.Input[str]] = None,
                 speed: Optional[pulumi.Input[str]] = None,
                 suspend_individual: Optional[pulumi.Input[str]] = None,
                 trunk_vlans: Optional[pulumi.Input[str]] = None,
                 user_configured_flags: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PortChannelInterfaceArgs.__new__(PortChannelInterfaceArgs)

            __props__.__dict__["access_vlan"] = access_vlan
            __props__.__dict__["admin_state"] = admin_state
            __props__.__dict__["auto_negotiation"] = auto_negotiation
            __props__.__dict__["bandwidth"] = bandwidth
            __props__.__dict__["delay"] = delay
            __props__.__dict__["description"] = description
            __props__.__dict__["device"] = device
            __props__.__dict__["duplex"] = duplex
            if interface_id is None and not opts.urn:
                raise TypeError("Missing required property 'interface_id'")
            __props__.__dict__["interface_id"] = interface_id
            __props__.__dict__["layer"] = layer
            __props__.__dict__["link_logging"] = link_logging
            __props__.__dict__["maximum_links"] = maximum_links
            __props__.__dict__["medium"] = medium
            __props__.__dict__["minimum_links"] = minimum_links
            __props__.__dict__["mode"] = mode
            __props__.__dict__["mtu"] = mtu
            __props__.__dict__["native_vlan"] = native_vlan
            __props__.__dict__["port_channel_mode"] = port_channel_mode
            __props__.__dict__["speed"] = speed
            __props__.__dict__["suspend_individual"] = suspend_individual
            __props__.__dict__["trunk_vlans"] = trunk_vlans
            __props__.__dict__["user_configured_flags"] = user_configured_flags
        super(PortChannelInterface, __self__).__init__(
            'nxos:index/portChannelInterface:PortChannelInterface',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_vlan: Optional[pulumi.Input[str]] = None,
            admin_state: Optional[pulumi.Input[str]] = None,
            auto_negotiation: Optional[pulumi.Input[str]] = None,
            bandwidth: Optional[pulumi.Input[int]] = None,
            delay: Optional[pulumi.Input[int]] = None,
            description: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            duplex: Optional[pulumi.Input[str]] = None,
            interface_id: Optional[pulumi.Input[str]] = None,
            layer: Optional[pulumi.Input[str]] = None,
            link_logging: Optional[pulumi.Input[str]] = None,
            maximum_links: Optional[pulumi.Input[int]] = None,
            medium: Optional[pulumi.Input[str]] = None,
            minimum_links: Optional[pulumi.Input[int]] = None,
            mode: Optional[pulumi.Input[str]] = None,
            mtu: Optional[pulumi.Input[int]] = None,
            native_vlan: Optional[pulumi.Input[str]] = None,
            port_channel_mode: Optional[pulumi.Input[str]] = None,
            speed: Optional[pulumi.Input[str]] = None,
            suspend_individual: Optional[pulumi.Input[str]] = None,
            trunk_vlans: Optional[pulumi.Input[str]] = None,
            user_configured_flags: Optional[pulumi.Input[str]] = None) -> 'PortChannelInterface':
        """
        Get an existing PortChannelInterface resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_vlan: Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] admin_state: Administrative port state. - Choices: `up`, `down` - Default value: `up`
        :param pulumi.Input[str] auto_negotiation: Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        :param pulumi.Input[int] bandwidth: The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
               value: `0`
        :param pulumi.Input[int] delay: The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        :param pulumi.Input[str] description: Interface description.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] duplex: Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        :param pulumi.Input[str] interface_id: Must match first field in the output of `show intf brief`. Example: `po1`.
        :param pulumi.Input[str] layer: Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        :param pulumi.Input[str] link_logging: Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        :param pulumi.Input[int] maximum_links: Maximum links. - Range: `1`-`32` - Default value: `32`
        :param pulumi.Input[str] medium: The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        :param pulumi.Input[int] minimum_links: Minimum links. - Range: `1`-`32` - Default value: `1`
        :param pulumi.Input[str] mode: Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
               `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        :param pulumi.Input[int] mtu: Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        :param pulumi.Input[str] native_vlan: Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        :param pulumi.Input[str] port_channel_mode: The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
               value: `on`
        :param pulumi.Input[str] speed: Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
               `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
               `auto`
        :param pulumi.Input[str] suspend_individual: Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        :param pulumi.Input[str] trunk_vlans: List of trunk VLANs. - Default value: `1-4094`
        :param pulumi.Input[str] user_configured_flags: Port User Config Flags.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PortChannelInterfaceState.__new__(_PortChannelInterfaceState)

        __props__.__dict__["access_vlan"] = access_vlan
        __props__.__dict__["admin_state"] = admin_state
        __props__.__dict__["auto_negotiation"] = auto_negotiation
        __props__.__dict__["bandwidth"] = bandwidth
        __props__.__dict__["delay"] = delay
        __props__.__dict__["description"] = description
        __props__.__dict__["device"] = device
        __props__.__dict__["duplex"] = duplex
        __props__.__dict__["interface_id"] = interface_id
        __props__.__dict__["layer"] = layer
        __props__.__dict__["link_logging"] = link_logging
        __props__.__dict__["maximum_links"] = maximum_links
        __props__.__dict__["medium"] = medium
        __props__.__dict__["minimum_links"] = minimum_links
        __props__.__dict__["mode"] = mode
        __props__.__dict__["mtu"] = mtu
        __props__.__dict__["native_vlan"] = native_vlan
        __props__.__dict__["port_channel_mode"] = port_channel_mode
        __props__.__dict__["speed"] = speed
        __props__.__dict__["suspend_individual"] = suspend_individual
        __props__.__dict__["trunk_vlans"] = trunk_vlans
        __props__.__dict__["user_configured_flags"] = user_configured_flags
        return PortChannelInterface(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessVlan")
    def access_vlan(self) -> pulumi.Output[str]:
        """
        Access VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        """
        return pulumi.get(self, "access_vlan")

    @property
    @pulumi.getter(name="adminState")
    def admin_state(self) -> pulumi.Output[str]:
        """
        Administrative port state. - Choices: `up`, `down` - Default value: `up`
        """
        return pulumi.get(self, "admin_state")

    @property
    @pulumi.getter(name="autoNegotiation")
    def auto_negotiation(self) -> pulumi.Output[str]:
        """
        Administrative port auto-negotiation. - Choices: `on`, `off`, `25G` - Default value: `on`
        """
        return pulumi.get(self, "auto_negotiation")

    @property
    @pulumi.getter
    def bandwidth(self) -> pulumi.Output[int]:
        """
        The bandwidth parameter for a routed interface, port channel, or subinterface. - Range: `0`-`3200000000` - Default
        value: `0`
        """
        return pulumi.get(self, "bandwidth")

    @property
    @pulumi.getter
    def delay(self) -> pulumi.Output[int]:
        """
        The administrative port delay time. - Range: `1`-`16777215` - Default value: `1`
        """
        return pulumi.get(self, "delay")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Interface description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def duplex(self) -> pulumi.Output[str]:
        """
        Duplex. - Choices: `auto`, `full`, `half` - Default value: `auto`
        """
        return pulumi.get(self, "duplex")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> pulumi.Output[str]:
        """
        Must match first field in the output of `show intf brief`. Example: `po1`.
        """
        return pulumi.get(self, "interface_id")

    @property
    @pulumi.getter
    def layer(self) -> pulumi.Output[str]:
        """
        Administrative port layer. - Choices: `Layer2`, `Layer3` - Default value: `Layer2`
        """
        return pulumi.get(self, "layer")

    @property
    @pulumi.getter(name="linkLogging")
    def link_logging(self) -> pulumi.Output[str]:
        """
        Administrative link logging. - Choices: `default`, `enable`, `disable` - Default value: `default`
        """
        return pulumi.get(self, "link_logging")

    @property
    @pulumi.getter(name="maximumLinks")
    def maximum_links(self) -> pulumi.Output[int]:
        """
        Maximum links. - Range: `1`-`32` - Default value: `32`
        """
        return pulumi.get(self, "maximum_links")

    @property
    @pulumi.getter
    def medium(self) -> pulumi.Output[str]:
        """
        The administrative port medium type. - Choices: `broadcast`, `p2p` - Default value: `broadcast`
        """
        return pulumi.get(self, "medium")

    @property
    @pulumi.getter(name="minimumLinks")
    def minimum_links(self) -> pulumi.Output[int]:
        """
        Minimum links. - Range: `1`-`32` - Default value: `1`
        """
        return pulumi.get(self, "minimum_links")

    @property
    @pulumi.getter
    def mode(self) -> pulumi.Output[str]:
        """
        Administrative port mode. - Choices: `access`, `trunk`, `fex-fabric`, `dot1q-tunnel`, `promiscuous`, `host`,
        `trunk_secondary`, `trunk_promiscuous`, `vntag` - Default value: `access`
        """
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def mtu(self) -> pulumi.Output[int]:
        """
        Administrative port MTU. - Range: `576`-`9216` - Default value: `1500`
        """
        return pulumi.get(self, "mtu")

    @property
    @pulumi.getter(name="nativeVlan")
    def native_vlan(self) -> pulumi.Output[str]:
        """
        Native VLAN. Possible values are `unknown`, `vlan-XX` or `vxlan-XX`. - Default value: `vlan-1`
        """
        return pulumi.get(self, "native_vlan")

    @property
    @pulumi.getter(name="portChannelMode")
    def port_channel_mode(self) -> pulumi.Output[str]:
        """
        The aggregated interface protocol channel mode. - Choices: `on`, `static`, `active`, `passive`, `mac-pin` - Default
        value: `on`
        """
        return pulumi.get(self, "port_channel_mode")

    @property
    @pulumi.getter
    def speed(self) -> pulumi.Output[str]:
        """
        Administrative port speed. - Choices: `unknown`, `100M`, `1G`, `10G`, `40G`, `auto`, `auto 100M`, `auto 100M 1G`,
        `100G`, `25G`, `10M`, `50G`, `200G`, `400G`, `2.5G`, `5G`, `auto 2.5G 5G 10G`, `auto 100M 1G 2.5G 5G` - Default value:
        `auto`
        """
        return pulumi.get(self, "speed")

    @property
    @pulumi.getter(name="suspendIndividual")
    def suspend_individual(self) -> pulumi.Output[str]:
        """
        Suspend Individual Port. - Choices: `enable`, `disable` - Default value: `enable`
        """
        return pulumi.get(self, "suspend_individual")

    @property
    @pulumi.getter(name="trunkVlans")
    def trunk_vlans(self) -> pulumi.Output[str]:
        """
        List of trunk VLANs. - Default value: `1-4094`
        """
        return pulumi.get(self, "trunk_vlans")

    @property
    @pulumi.getter(name="userConfiguredFlags")
    def user_configured_flags(self) -> pulumi.Output[Optional[str]]:
        """
        Port User Config Flags.
        """
        return pulumi.get(self, "user_configured_flags")

