# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['RouteMapRuleEntryArgs', 'RouteMapRuleEntry']

@pulumi.input_type
class RouteMapRuleEntryArgs:
    def __init__(__self__, *,
                 order: pulumi.Input[int],
                 rule_name: pulumi.Input[str],
                 action: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RouteMapRuleEntry resource.
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        :param pulumi.Input[str] action: Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        pulumi.set(__self__, "order", order)
        pulumi.set(__self__, "rule_name", rule_name)
        if action is not None:
            pulumi.set(__self__, "action", action)
        if device is not None:
            pulumi.set(__self__, "device", device)

    @property
    @pulumi.getter
    def order(self) -> pulumi.Input[int]:
        """
        Route-Map Rule Entry order. - Range: `0`-`65535`
        """
        return pulumi.get(self, "order")

    @order.setter
    def order(self, value: pulumi.Input[int]):
        pulumi.set(self, "order", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> pulumi.Input[str]:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "rule_name", value)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)


@pulumi.input_type
class _RouteMapRuleEntryState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 order: Optional[pulumi.Input[int]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RouteMapRuleEntry resources.
        :param pulumi.Input[str] action: Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if order is not None:
            pulumi.set(__self__, "order", order)
        if rule_name is not None:
            pulumi.set(__self__, "rule_name", rule_name)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def order(self) -> Optional[pulumi.Input[int]]:
        """
        Route-Map Rule Entry order. - Range: `0`-`65535`
        """
        return pulumi.get(self, "order")

    @order.setter
    def order(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "order", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> Optional[pulumi.Input[str]]:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_name", value)


class RouteMapRuleEntry(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 order: Optional[pulumi.Input[int]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a Route-Map Rule Entry configuration.

        - API Documentation: [rtmapEntry](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtmap:Entry/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.RouteMapRuleEntry("example",
            action="permit",
            order=10,
            rule_name="RULE1")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/routeMapRuleEntry:RouteMapRuleEntry example "sys/rpm/rtmap-[RULE1]/ent-[10]"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RouteMapRuleEntryArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a Route-Map Rule Entry configuration.

        - API Documentation: [rtmapEntry](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtmap:Entry/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.RouteMapRuleEntry("example",
            action="permit",
            order=10,
            rule_name="RULE1")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/routeMapRuleEntry:RouteMapRuleEntry example "sys/rpm/rtmap-[RULE1]/ent-[10]"
        ```

        :param str resource_name: The name of the resource.
        :param RouteMapRuleEntryArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RouteMapRuleEntryArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 order: Optional[pulumi.Input[int]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RouteMapRuleEntryArgs.__new__(RouteMapRuleEntryArgs)

            __props__.__dict__["action"] = action
            __props__.__dict__["device"] = device
            if order is None and not opts.urn:
                raise TypeError("Missing required property 'order'")
            __props__.__dict__["order"] = order
            if rule_name is None and not opts.urn:
                raise TypeError("Missing required property 'rule_name'")
            __props__.__dict__["rule_name"] = rule_name
        super(RouteMapRuleEntry, __self__).__init__(
            'nxos:index/routeMapRuleEntry:RouteMapRuleEntry',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            order: Optional[pulumi.Input[int]] = None,
            rule_name: Optional[pulumi.Input[str]] = None) -> 'RouteMapRuleEntry':
        """
        Get an existing RouteMapRuleEntry resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RouteMapRuleEntryState.__new__(_RouteMapRuleEntryState)

        __props__.__dict__["action"] = action
        __props__.__dict__["device"] = device
        __props__.__dict__["order"] = order
        __props__.__dict__["rule_name"] = rule_name
        return RouteMapRuleEntry(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        Route-Map Rule Entry action. - Choices: `deny`, `permit` - Default value: `permit`
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def order(self) -> pulumi.Output[int]:
        """
        Route-Map Rule Entry order. - Range: `0`-`65535`
        """
        return pulumi.get(self, "order")

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> pulumi.Output[str]:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")

