# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['RouteMapRuleEntrySetRegularCommunityArgs', 'RouteMapRuleEntrySetRegularCommunity']

@pulumi.input_type
class RouteMapRuleEntrySetRegularCommunityArgs:
    def __init__(__self__, *,
                 order: pulumi.Input[int],
                 rule_name: pulumi.Input[str],
                 additive: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 no_community: Optional[pulumi.Input[str]] = None,
                 set_criteria: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RouteMapRuleEntrySetRegularCommunity resource.
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        :param pulumi.Input[str] additive: Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] no_community: Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] set_criteria: Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
               `none`
        """
        pulumi.set(__self__, "order", order)
        pulumi.set(__self__, "rule_name", rule_name)
        if additive is not None:
            pulumi.set(__self__, "additive", additive)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if no_community is not None:
            pulumi.set(__self__, "no_community", no_community)
        if set_criteria is not None:
            pulumi.set(__self__, "set_criteria", set_criteria)

    @property
    @pulumi.getter
    def order(self) -> pulumi.Input[int]:
        """
        Route-Map Rule Entry order. - Range: `0`-`65535`
        """
        return pulumi.get(self, "order")

    @order.setter
    def order(self, value: pulumi.Input[int]):
        pulumi.set(self, "order", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> pulumi.Input[str]:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "rule_name", value)

    @property
    @pulumi.getter
    def additive(self) -> Optional[pulumi.Input[str]]:
        """
        Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "additive")

    @additive.setter
    def additive(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "additive", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="noCommunity")
    def no_community(self) -> Optional[pulumi.Input[str]]:
        """
        Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "no_community")

    @no_community.setter
    def no_community(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "no_community", value)

    @property
    @pulumi.getter(name="setCriteria")
    def set_criteria(self) -> Optional[pulumi.Input[str]]:
        """
        Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
        `none`
        """
        return pulumi.get(self, "set_criteria")

    @set_criteria.setter
    def set_criteria(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "set_criteria", value)


@pulumi.input_type
class _RouteMapRuleEntrySetRegularCommunityState:
    def __init__(__self__, *,
                 additive: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 no_community: Optional[pulumi.Input[str]] = None,
                 order: Optional[pulumi.Input[int]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 set_criteria: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RouteMapRuleEntrySetRegularCommunity resources.
        :param pulumi.Input[str] additive: Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] no_community: Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        :param pulumi.Input[str] set_criteria: Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
               `none`
        """
        if additive is not None:
            pulumi.set(__self__, "additive", additive)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if no_community is not None:
            pulumi.set(__self__, "no_community", no_community)
        if order is not None:
            pulumi.set(__self__, "order", order)
        if rule_name is not None:
            pulumi.set(__self__, "rule_name", rule_name)
        if set_criteria is not None:
            pulumi.set(__self__, "set_criteria", set_criteria)

    @property
    @pulumi.getter
    def additive(self) -> Optional[pulumi.Input[str]]:
        """
        Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "additive")

    @additive.setter
    def additive(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "additive", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="noCommunity")
    def no_community(self) -> Optional[pulumi.Input[str]]:
        """
        Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "no_community")

    @no_community.setter
    def no_community(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "no_community", value)

    @property
    @pulumi.getter
    def order(self) -> Optional[pulumi.Input[int]]:
        """
        Route-Map Rule Entry order. - Range: `0`-`65535`
        """
        return pulumi.get(self, "order")

    @order.setter
    def order(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "order", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> Optional[pulumi.Input[str]]:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_name", value)

    @property
    @pulumi.getter(name="setCriteria")
    def set_criteria(self) -> Optional[pulumi.Input[str]]:
        """
        Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
        `none`
        """
        return pulumi.get(self, "set_criteria")

    @set_criteria.setter
    def set_criteria(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "set_criteria", value)


class RouteMapRuleEntrySetRegularCommunity(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 additive: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 no_community: Optional[pulumi.Input[str]] = None,
                 order: Optional[pulumi.Input[int]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 set_criteria: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a Set Community configuration in a Route-Map Rule Entry.

        - API Documentation: [rtmapSetRegComm](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtmap:SetRegComm/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.RouteMapRuleEntrySetRegularCommunity("example",
            additive="disabled",
            no_community="disabled",
            order=10,
            rule_name="RULE1",
            set_criteria="none")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/routeMapRuleEntrySetRegularCommunity:RouteMapRuleEntrySetRegularCommunity example "sys/rpm/rtmap-[RULE1]/ent-[10]/sregcomm"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] additive: Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] no_community: Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        :param pulumi.Input[str] set_criteria: Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
               `none`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RouteMapRuleEntrySetRegularCommunityArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a Set Community configuration in a Route-Map Rule Entry.

        - API Documentation: [rtmapSetRegComm](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtmap:SetRegComm/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.RouteMapRuleEntrySetRegularCommunity("example",
            additive="disabled",
            no_community="disabled",
            order=10,
            rule_name="RULE1",
            set_criteria="none")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/routeMapRuleEntrySetRegularCommunity:RouteMapRuleEntrySetRegularCommunity example "sys/rpm/rtmap-[RULE1]/ent-[10]/sregcomm"
        ```

        :param str resource_name: The name of the resource.
        :param RouteMapRuleEntrySetRegularCommunityArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RouteMapRuleEntrySetRegularCommunityArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 additive: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 no_community: Optional[pulumi.Input[str]] = None,
                 order: Optional[pulumi.Input[int]] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 set_criteria: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RouteMapRuleEntrySetRegularCommunityArgs.__new__(RouteMapRuleEntrySetRegularCommunityArgs)

            __props__.__dict__["additive"] = additive
            __props__.__dict__["device"] = device
            __props__.__dict__["no_community"] = no_community
            if order is None and not opts.urn:
                raise TypeError("Missing required property 'order'")
            __props__.__dict__["order"] = order
            if rule_name is None and not opts.urn:
                raise TypeError("Missing required property 'rule_name'")
            __props__.__dict__["rule_name"] = rule_name
            __props__.__dict__["set_criteria"] = set_criteria
        super(RouteMapRuleEntrySetRegularCommunity, __self__).__init__(
            'nxos:index/routeMapRuleEntrySetRegularCommunity:RouteMapRuleEntrySetRegularCommunity',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            additive: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            no_community: Optional[pulumi.Input[str]] = None,
            order: Optional[pulumi.Input[int]] = None,
            rule_name: Optional[pulumi.Input[str]] = None,
            set_criteria: Optional[pulumi.Input[str]] = None) -> 'RouteMapRuleEntrySetRegularCommunity':
        """
        Get an existing RouteMapRuleEntrySetRegularCommunity resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] additive: Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] no_community: Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        :param pulumi.Input[int] order: Route-Map Rule Entry order. - Range: `0`-`65535`
        :param pulumi.Input[str] rule_name: Route Map rule name.
        :param pulumi.Input[str] set_criteria: Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
               `none`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RouteMapRuleEntrySetRegularCommunityState.__new__(_RouteMapRuleEntrySetRegularCommunityState)

        __props__.__dict__["additive"] = additive
        __props__.__dict__["device"] = device
        __props__.__dict__["no_community"] = no_community
        __props__.__dict__["order"] = order
        __props__.__dict__["rule_name"] = rule_name
        __props__.__dict__["set_criteria"] = set_criteria
        return RouteMapRuleEntrySetRegularCommunity(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def additive(self) -> pulumi.Output[str]:
        """
        Option to add to an existing community. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "additive")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="noCommunity")
    def no_community(self) -> pulumi.Output[str]:
        """
        Option to have no community attribute. - Choices: `enabled`, `disabled` - Default value: `disabled`
        """
        return pulumi.get(self, "no_community")

    @property
    @pulumi.getter
    def order(self) -> pulumi.Output[int]:
        """
        Route-Map Rule Entry order. - Range: `0`-`65535`
        """
        return pulumi.get(self, "order")

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> pulumi.Output[str]:
        """
        Route Map rule name.
        """
        return pulumi.get(self, "rule_name")

    @property
    @pulumi.getter(name="setCriteria")
    def set_criteria(self) -> pulumi.Output[str]:
        """
        Operation on the current community. - Choices: `none`, `append`, `replace`, `igp`, `pre-bestpath` - Default value:
        `none`
        """
        return pulumi.get(self, "set_criteria")

