# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['VpcInterfaceArgs', 'VpcInterface']

@pulumi.input_type
class VpcInterfaceArgs:
    def __init__(__self__, *,
                 vpc_interface_id: pulumi.Input[int],
                 device: Optional[pulumi.Input[str]] = None,
                 port_channel_interface_dn: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a VpcInterface resource.
        :param pulumi.Input[int] vpc_interface_id: The vPC interface identifier. - Range: `1`-`16384`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] port_channel_interface_dn: Port-channel interface DN.
        """
        pulumi.set(__self__, "vpc_interface_id", vpc_interface_id)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if port_channel_interface_dn is not None:
            pulumi.set(__self__, "port_channel_interface_dn", port_channel_interface_dn)

    @property
    @pulumi.getter(name="vpcInterfaceId")
    def vpc_interface_id(self) -> pulumi.Input[int]:
        """
        The vPC interface identifier. - Range: `1`-`16384`
        """
        return pulumi.get(self, "vpc_interface_id")

    @vpc_interface_id.setter
    def vpc_interface_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "vpc_interface_id", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="portChannelInterfaceDn")
    def port_channel_interface_dn(self) -> Optional[pulumi.Input[str]]:
        """
        Port-channel interface DN.
        """
        return pulumi.get(self, "port_channel_interface_dn")

    @port_channel_interface_dn.setter
    def port_channel_interface_dn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port_channel_interface_dn", value)


@pulumi.input_type
class _VpcInterfaceState:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 port_channel_interface_dn: Optional[pulumi.Input[str]] = None,
                 vpc_interface_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering VpcInterface resources.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] port_channel_interface_dn: Port-channel interface DN.
        :param pulumi.Input[int] vpc_interface_id: The vPC interface identifier. - Range: `1`-`16384`
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if port_channel_interface_dn is not None:
            pulumi.set(__self__, "port_channel_interface_dn", port_channel_interface_dn)
        if vpc_interface_id is not None:
            pulumi.set(__self__, "vpc_interface_id", vpc_interface_id)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter(name="portChannelInterfaceDn")
    def port_channel_interface_dn(self) -> Optional[pulumi.Input[str]]:
        """
        Port-channel interface DN.
        """
        return pulumi.get(self, "port_channel_interface_dn")

    @port_channel_interface_dn.setter
    def port_channel_interface_dn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "port_channel_interface_dn", value)

    @property
    @pulumi.getter(name="vpcInterfaceId")
    def vpc_interface_id(self) -> Optional[pulumi.Input[int]]:
        """
        The vPC interface identifier. - Range: `1`-`16384`
        """
        return pulumi.get(self, "vpc_interface_id")

    @vpc_interface_id.setter
    def vpc_interface_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "vpc_interface_id", value)


class VpcInterface(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 port_channel_interface_dn: Optional[pulumi.Input[str]] = None,
                 vpc_interface_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        This resource can manage the vPC interface configuration.

        - API Documentation: [vpcIf](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/System/vpc:If/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.VpcInterface("example",
            port_channel_interface_dn="sys/intf/aggr-[po1]",
            vpc_interface_id=1)
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/vpcInterface:VpcInterface example "sys/vpc/inst/dom/if-[1]"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] port_channel_interface_dn: Port-channel interface DN.
        :param pulumi.Input[int] vpc_interface_id: The vPC interface identifier. - Range: `1`-`16384`
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VpcInterfaceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage the vPC interface configuration.

        - API Documentation: [vpcIf](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/System/vpc:If/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.VpcInterface("example",
            port_channel_interface_dn="sys/intf/aggr-[po1]",
            vpc_interface_id=1)
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/vpcInterface:VpcInterface example "sys/vpc/inst/dom/if-[1]"
        ```

        :param str resource_name: The name of the resource.
        :param VpcInterfaceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VpcInterfaceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 port_channel_interface_dn: Optional[pulumi.Input[str]] = None,
                 vpc_interface_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VpcInterfaceArgs.__new__(VpcInterfaceArgs)

            __props__.__dict__["device"] = device
            __props__.__dict__["port_channel_interface_dn"] = port_channel_interface_dn
            if vpc_interface_id is None and not opts.urn:
                raise TypeError("Missing required property 'vpc_interface_id'")
            __props__.__dict__["vpc_interface_id"] = vpc_interface_id
        super(VpcInterface, __self__).__init__(
            'nxos:index/vpcInterface:VpcInterface',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            device: Optional[pulumi.Input[str]] = None,
            port_channel_interface_dn: Optional[pulumi.Input[str]] = None,
            vpc_interface_id: Optional[pulumi.Input[int]] = None) -> 'VpcInterface':
        """
        Get an existing VpcInterface resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] port_channel_interface_dn: Port-channel interface DN.
        :param pulumi.Input[int] vpc_interface_id: The vPC interface identifier. - Range: `1`-`16384`
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VpcInterfaceState.__new__(_VpcInterfaceState)

        __props__.__dict__["device"] = device
        __props__.__dict__["port_channel_interface_dn"] = port_channel_interface_dn
        __props__.__dict__["vpc_interface_id"] = vpc_interface_id
        return VpcInterface(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="portChannelInterfaceDn")
    def port_channel_interface_dn(self) -> pulumi.Output[Optional[str]]:
        """
        Port-channel interface DN.
        """
        return pulumi.get(self, "port_channel_interface_dn")

    @property
    @pulumi.getter(name="vpcInterfaceId")
    def vpc_interface_id(self) -> pulumi.Output[int]:
        """
        The vPC interface identifier. - Range: `1`-`16384`
        """
        return pulumi.get(self, "vpc_interface_id")

