# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['VrfRouteTargetArgs', 'VrfRouteTarget']

@pulumi.input_type
class VrfRouteTargetArgs:
    def __init__(__self__, *,
                 address_family: pulumi.Input[str],
                 direction: pulumi.Input[str],
                 route_target: pulumi.Input[str],
                 route_target_address_family: pulumi.Input[str],
                 vrf: pulumi.Input[str],
                 device: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a VrfRouteTarget resource.
        :param pulumi.Input[str] address_family: Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        :param pulumi.Input[str] direction: Route Target direction. - Choices: `import`, `export`
        :param pulumi.Input[str] route_target: Route Target in NX-OS DME format.
        :param pulumi.Input[str] route_target_address_family: Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        :param pulumi.Input[str] vrf: VRF name.
        :param pulumi.Input[str] device: A device name from the provider configuration.
        """
        pulumi.set(__self__, "address_family", address_family)
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "route_target", route_target)
        pulumi.set(__self__, "route_target_address_family", route_target_address_family)
        pulumi.set(__self__, "vrf", vrf)
        if device is not None:
            pulumi.set(__self__, "device", device)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> pulumi.Input[str]:
        """
        Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        """
        return pulumi.get(self, "address_family")

    @address_family.setter
    def address_family(self, value: pulumi.Input[str]):
        pulumi.set(self, "address_family", value)

    @property
    @pulumi.getter
    def direction(self) -> pulumi.Input[str]:
        """
        Route Target direction. - Choices: `import`, `export`
        """
        return pulumi.get(self, "direction")

    @direction.setter
    def direction(self, value: pulumi.Input[str]):
        pulumi.set(self, "direction", value)

    @property
    @pulumi.getter(name="routeTarget")
    def route_target(self) -> pulumi.Input[str]:
        """
        Route Target in NX-OS DME format.
        """
        return pulumi.get(self, "route_target")

    @route_target.setter
    def route_target(self, value: pulumi.Input[str]):
        pulumi.set(self, "route_target", value)

    @property
    @pulumi.getter(name="routeTargetAddressFamily")
    def route_target_address_family(self) -> pulumi.Input[str]:
        """
        Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        """
        return pulumi.get(self, "route_target_address_family")

    @route_target_address_family.setter
    def route_target_address_family(self, value: pulumi.Input[str]):
        pulumi.set(self, "route_target_address_family", value)

    @property
    @pulumi.getter
    def vrf(self) -> pulumi.Input[str]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

    @vrf.setter
    def vrf(self, value: pulumi.Input[str]):
        pulumi.set(self, "vrf", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)


@pulumi.input_type
class _VrfRouteTargetState:
    def __init__(__self__, *,
                 address_family: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 route_target: Optional[pulumi.Input[str]] = None,
                 route_target_address_family: Optional[pulumi.Input[str]] = None,
                 vrf: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering VrfRouteTarget resources.
        :param pulumi.Input[str] address_family: Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] direction: Route Target direction. - Choices: `import`, `export`
        :param pulumi.Input[str] route_target: Route Target in NX-OS DME format.
        :param pulumi.Input[str] route_target_address_family: Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        :param pulumi.Input[str] vrf: VRF name.
        """
        if address_family is not None:
            pulumi.set(__self__, "address_family", address_family)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if direction is not None:
            pulumi.set(__self__, "direction", direction)
        if route_target is not None:
            pulumi.set(__self__, "route_target", route_target)
        if route_target_address_family is not None:
            pulumi.set(__self__, "route_target_address_family", route_target_address_family)
        if vrf is not None:
            pulumi.set(__self__, "vrf", vrf)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> Optional[pulumi.Input[str]]:
        """
        Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        """
        return pulumi.get(self, "address_family")

    @address_family.setter
    def address_family(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address_family", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def direction(self) -> Optional[pulumi.Input[str]]:
        """
        Route Target direction. - Choices: `import`, `export`
        """
        return pulumi.get(self, "direction")

    @direction.setter
    def direction(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "direction", value)

    @property
    @pulumi.getter(name="routeTarget")
    def route_target(self) -> Optional[pulumi.Input[str]]:
        """
        Route Target in NX-OS DME format.
        """
        return pulumi.get(self, "route_target")

    @route_target.setter
    def route_target(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "route_target", value)

    @property
    @pulumi.getter(name="routeTargetAddressFamily")
    def route_target_address_family(self) -> Optional[pulumi.Input[str]]:
        """
        Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        """
        return pulumi.get(self, "route_target_address_family")

    @route_target_address_family.setter
    def route_target_address_family(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "route_target_address_family", value)

    @property
    @pulumi.getter
    def vrf(self) -> Optional[pulumi.Input[str]]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

    @vrf.setter
    def vrf(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vrf", value)


class VrfRouteTarget(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 route_target: Optional[pulumi.Input[str]] = None,
                 route_target_address_family: Optional[pulumi.Input[str]] = None,
                 vrf: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a VRF Route Target Entry.

        - API Documentation: [rtctrlRttEntry](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtctrl:RttEntry/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.VrfRouteTarget("example",
            address_family="ipv4-ucast",
            direction="import",
            route_target="route-target:as2-nn2:2:2",
            route_target_address_family="ipv4-ucast",
            vrf="VRF1")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/vrfRouteTarget:VrfRouteTarget example "sys/inst-[VRF1]/dom-[VRF1]/af-[ipv4-ucast]/ctrl-[ipv4-ucast]/rttp-[import]/ent-[route-target:as2-nn2:2:2]"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address_family: Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] direction: Route Target direction. - Choices: `import`, `export`
        :param pulumi.Input[str] route_target: Route Target in NX-OS DME format.
        :param pulumi.Input[str] route_target_address_family: Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        :param pulumi.Input[str] vrf: VRF name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VrfRouteTargetArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a VRF Route Target Entry.

        - API Documentation: [rtctrlRttEntry](https://pubhub.devnetcloud.com/media/dme-docs-10-2-2/docs/Routing%20and%20Forwarding/rtctrl:RttEntry/)

        ## Example Usage

        ```python
        import pulumi
        import lbrlabs_pulumi_nxos as nxos

        example = nxos.VrfRouteTarget("example",
            address_family="ipv4-ucast",
            direction="import",
            route_target="route-target:as2-nn2:2:2",
            route_target_address_family="ipv4-ucast",
            vrf="VRF1")
        ```

        ## Import

        ```sh
         $ pulumi import nxos:index/vrfRouteTarget:VrfRouteTarget example "sys/inst-[VRF1]/dom-[VRF1]/af-[ipv4-ucast]/ctrl-[ipv4-ucast]/rttp-[import]/ent-[route-target:as2-nn2:2:2]"
        ```

        :param str resource_name: The name of the resource.
        :param VrfRouteTargetArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VrfRouteTargetArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_family: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 route_target: Optional[pulumi.Input[str]] = None,
                 route_target_address_family: Optional[pulumi.Input[str]] = None,
                 vrf: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VrfRouteTargetArgs.__new__(VrfRouteTargetArgs)

            if address_family is None and not opts.urn:
                raise TypeError("Missing required property 'address_family'")
            __props__.__dict__["address_family"] = address_family
            __props__.__dict__["device"] = device
            if direction is None and not opts.urn:
                raise TypeError("Missing required property 'direction'")
            __props__.__dict__["direction"] = direction
            if route_target is None and not opts.urn:
                raise TypeError("Missing required property 'route_target'")
            __props__.__dict__["route_target"] = route_target
            if route_target_address_family is None and not opts.urn:
                raise TypeError("Missing required property 'route_target_address_family'")
            __props__.__dict__["route_target_address_family"] = route_target_address_family
            if vrf is None and not opts.urn:
                raise TypeError("Missing required property 'vrf'")
            __props__.__dict__["vrf"] = vrf
        super(VrfRouteTarget, __self__).__init__(
            'nxos:index/vrfRouteTarget:VrfRouteTarget',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            address_family: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            direction: Optional[pulumi.Input[str]] = None,
            route_target: Optional[pulumi.Input[str]] = None,
            route_target_address_family: Optional[pulumi.Input[str]] = None,
            vrf: Optional[pulumi.Input[str]] = None) -> 'VrfRouteTarget':
        """
        Get an existing VrfRouteTarget resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address_family: Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        :param pulumi.Input[str] device: A device name from the provider configuration.
        :param pulumi.Input[str] direction: Route Target direction. - Choices: `import`, `export`
        :param pulumi.Input[str] route_target: Route Target in NX-OS DME format.
        :param pulumi.Input[str] route_target_address_family: Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        :param pulumi.Input[str] vrf: VRF name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VrfRouteTargetState.__new__(_VrfRouteTargetState)

        __props__.__dict__["address_family"] = address_family
        __props__.__dict__["device"] = device
        __props__.__dict__["direction"] = direction
        __props__.__dict__["route_target"] = route_target
        __props__.__dict__["route_target_address_family"] = route_target_address_family
        __props__.__dict__["vrf"] = vrf
        return VrfRouteTarget(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="addressFamily")
    def address_family(self) -> pulumi.Output[str]:
        """
        Address family. - Choices: `ipv4-ucast`, `ipv6-ucast`
        """
        return pulumi.get(self, "address_family")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[Optional[str]]:
        """
        A device name from the provider configuration.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def direction(self) -> pulumi.Output[str]:
        """
        Route Target direction. - Choices: `import`, `export`
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="routeTarget")
    def route_target(self) -> pulumi.Output[str]:
        """
        Route Target in NX-OS DME format.
        """
        return pulumi.get(self, "route_target")

    @property
    @pulumi.getter(name="routeTargetAddressFamily")
    def route_target_address_family(self) -> pulumi.Output[str]:
        """
        Route Target Address Family. - Choices: `ipv4-ucast`, `ipv6-ucast`, `l2vpn-evpn`
        """
        return pulumi.get(self, "route_target_address_family")

    @property
    @pulumi.getter
    def vrf(self) -> pulumi.Output[str]:
        """
        VRF name.
        """
        return pulumi.get(self, "vrf")

